%macro SNPTraitAssocMacro(survey=0,imputed=0,kmodel=0,lsm=0, pest=1,covp = 1,osig=0, snpsnp=0);

	/*begin: Luciano*/
	%if %symexist(OutputRSquare) = 0 %then 
		%let OutputRSquare= NO;
		
	%if %symexist(GetNumGeno) = 0 %then 
		%let GetNumGeno = 0;

	%if %symexist(GetCovParms) = 0 %then 
		%let GetCovParms = 0;
	
	%if %symexist(selMarkerVars_g) = 0 %then
		%let selMarkerVars_g = ;
	
	%if %symexist(selmarkervarsorder_g) = 0 %then
		%let selmarkervarsorder_g = ;
		
	%if %symexist(selFixedEff_g) = 0 %then
		%let selFixedEff_g = ;
		
	%if %symexist(selMarkerVars_t) = 0 %then
		%let selMarkerVars_t = ;
	
	%if %symexist(selmarkervarsorder_t) = 0 %then
		%let selmarkervarsorder_t = ;
		
	%if %symexist(selFixedEff_t) = 0 %then
		%let selFixedEff_t = ;
		
	%if %symexist(QKSelProf) = 0 %then
		%let QKSelProf = 0;
		
	%let ParmsStmt_g = &ParmsStmt;
	%let ParmsStmt_t = &ParmsStmt;
	
	%if %symexist(OutputFitStat)=0 %then %do;
		%let OutputFitStat = NO;
		%global PlotFitVars;
		%let PlotFitVars=0;
	%end;
	%else %if %upcase(&OutputFitStat)=YES %then %do;	
		%global PlotFitVars Group1OverlayVars Group2OverlayVars Group3OverlayVars;
		%let PlotFitVars=1;
		%let Group1OverlayVars=;
		%let Group2OverlayVars=;
		%let Group3OverlayVars=;
		%if (&geno=1) %then %do;
			%if %index(%upcase(&WhichProc),MIXED) %then %do;
				%let Group1OverlayVars= _2_Res_Log_Likelihood_Genotype AIC_Smaller_is_Better_Genotype AICC_Smaller_is_Better_Genotype BIC_Smaller_is_Better_Genotype;
			%end; 
			%else %if %index(%upcase(&WhichProc),GLIMMIX) %then %do;
				%if (%upcase(&TraitType)=COUNT and %length(&RandEff)>0) 
					or (%upcase(&TraitType)=BINARY and %length(&RandEff)>0) %then %do;
					%if %upcase(&GMethod)=RSPL or %upcase(&GMethod)=RMPL %then %do;
						%let Group1OverlayVars= _2_Res_Log_Pseud_Likel_Genotype;
						%let Group2OverlayVars= Generalized_ChiSquare_Genotype;
						%let Group3OverlayVars= Gener_ChiSq_DF_Ratio_Genotype;					
					%end;
					%else %if %upcase(&GMethod)=MSPL or %upcase(&GMethod)=MMPL %then %do;
						%let Group1OverlayVars= _2_Log_Pseud_Likel_Genotype;
						%let Group2OverlayVars= Generalized_ChiSquare_Genotype;
						%let Group3OverlayVars= Gener_ChiSq_DF_Ratio_Genotype;
					%end;
					%else %if %upcase(&GMethod)=QUAD or %upcase(&GMethod)=LAPLACE %then %do;
						%let Group1OverlayVars= _2_Log_Likelihood_Genotype AIC_Smaller_is_Better_Genotype AICC_Smaller_is_Better_Genotype BIC_Smaller_is_Better_Genotype CAIC_smaller_is_better_Genotype HQIC_smaller_is_better_Genotype;
					%end;
				%end;
				%else %if %upcase(&TraitType)=COUNT and %length(&RandEff)=0 %then %do; 
					%let Group1OverlayVars= _2_Log_Likelihood_Genotype AIC_Smaller_is_Better_Genotype AICC_Smaller_is_Better_Genotype BIC_Smaller_is_Better_Genotype CAIC_smaller_is_better_Genotype HQIC_smaller_is_better_Genotype;	
					%let Group2OverlayVars= Pearson_ChiSquare_Genotype;	
					%let Group3OverlayVars= Pearson_ChiSq_DF_Ratio_Genotype;	
				%end;
				%else %if %upcase(&TraitType)=NOMINAL or %upcase(&TraitType)=ORDINAL %then %do;
					%if %upcase(&GMethod)=RSPL or %upcase(&GMethod)=RMPL %then %do;
						%let Group1OverlayVars= _2_Res_Log_Pseud_Likel_Genotype;
					%end;
					%else %if %upcase(&GMethod)=MSPL or %upcase(&GMethod)=MMPL %then %do;
						%let Group1OverlayVars= _2_Log_Pseud_Likel_Genotype;
					%end;
					%else %if %upcase(&GMethod)=QUAD or %upcase(&GMethod)=LAPLACE %then %do;
						%let Group1OverlayVars= _2_Log_Likelihood_Genotype AIC_Smaller_is_Better_Genotype AICC_Smaller_is_Better_Genotype BIC_Smaller_is_Better_Genotype CAIC_smaller_is_better_Genotype HQIC_smaller_is_better_Genotype;
					%end;
				%end;
				%else %if (%upcase(&TraitType)=BINARY and &kmodel=1) %then %do;
					%if %upcase(&GMethod)=RSPL or %upcase(&GMethod)=RMPL %then %do;
						%let Group1OverlayVars= _2_Res_Log_Pseud_Likel_Genotype;
						%let Group2OverlayVars= Generalized_ChiSquare_Genotype;
						%let Group3OverlayVars= Gener_ChiSq_DF_Ratio_Genotype;
					%end;
					%else %if %upcase(&GMethod)=MSPL or %upcase(&GMethod)=MMPL %then %do;
						%let Group1OverlayVars= _2_Log_Pseud_Likel_Genotype;
						%let Group2OverlayVars= Generalized_ChiSquare_Genotype;
						%let Group3OverlayVars= Gener_ChiSq_DF_Ratio_Genotype;										
					%end;
				%end;
			%end;
			%else %if %index(%upcase(&WhichProc),PHREG) %then %do;
				%let Group1OverlayVars= _2_LOG_L_Genotype AIC_Genotype SBC_Genotype;
			%end;
			%else %if %index(%upcase(&WhichProc),LOGISTIC) %then %do;
				%let Group1OverlayVars= AIC_Genotype SC_Genotype _2_Log_L_Genotype;
			%end;
		%end;
		
		%if (&trend=1) %then %do;
			%if %index(%upcase(&WhichProc),MIXED) %then %do;
				%let Group1OverlayVars= &Group1OverlayVars _2_Res_Log_Likelihood_Trend AIC_Smaller_is_Better_Trend AICC_Smaller_is_Better_Trend BIC_Smaller_is_Better_Trend;
			%end; 
			%else %if %index(%upcase(&WhichProc),GLIMMIX) %then %do;
				%if (%upcase(&TraitType)=COUNT and %length(&RandEff)>0) 
					or (%upcase(&TraitType)=BINARY and %length(&RandEff)>0) %then %do;
					%if %upcase(&GMethod)=RSPL or %upcase(&GMethod)=RMPL %then %do;
						%let Group1OverlayVars= &Group1OverlayVars _2_Res_Log_Pseud_Likel_Trend;
						%let Group2OverlayVars= &Group2OverlayVars Generalized_ChiSquare_Trend;
						%let Group3OverlayVars= &Group3OverlayVars Gener_ChiSq_DF_Ratio_Trend;					
					%end;
					%else %if %upcase(&GMethod)=MSPL or %upcase(&GMethod)=MMPL %then %do;
						%let Group1OverlayVars= &Group1OverlayVars _2_Log_Pseud_Likel_Trend;
						%let Group2OverlayVars= &Group2OverlayVars Generalized_ChiSquare_Trend;
						%let Group3OverlayVars= &Group3OverlayVars Gener_ChiSq_DF_Ratio_Trend;
					%end;
					%else %if %upcase(&GMethod)=QUAD or %upcase(&GMethod)=LAPLACE %then %do;
						%let Group1OverlayVars= &Group1OverlayVars _2_Log_Likelihood_Trend AIC_Smaller_is_Better_Trend AICC_Smaller_is_Better_Trend BIC_Smaller_is_Better_Trend CAIC_smaller_is_better_Trend HQIC_smaller_is_better_Trend;
					%end;
				%end;
				%else %if %upcase(&TraitType)=COUNT and %length(&RandEff)=0 %then %do; 
					%let Group1OverlayVars= &Group1OverlayVars _2_Log_Likelihood_Trend AIC_Smaller_is_Better_Trend AICC_Smaller_is_Better_Trend BIC_Smaller_is_Better_Trend CAIC_smaller_is_better_Trend HQIC_smaller_is_better_Trend;	
					%let Group2OverlayVars= &Group2OverlayVars Pearson_ChiSquare_Trend;	
					%let Group3OverlayVars= &Group3OverlayVars Pearson_ChiSq_DF_Ratio_Trend;	
				%end;
				%else %if %upcase(&TraitType)=NOMINAL or %upcase(&TraitType)=ORDINAL %then %do;
					%if %upcase(&GMethod)=RSPL or %upcase(&GMethod)=RMPL %then %do;
						%let Group1OverlayVars= &Group1OverlayVars _2_Res_Log_Pseud_Likel_Trend;
					%end;
					%else %if %upcase(&GMethod)=MSPL or %upcase(&GMethod)=MMPL %then %do;
						%let Group1OverlayVars= &Group1OverlayVars _2_Log_Pseud_Likel_Trend;
					%end;
					%else %if %upcase(&GMethod)=QUAD or %upcase(&GMethod)=LAPLACE %then %do;
						%let Group1OverlayVars= &Group1OverlayVars _2_Log_Likelihood_Trend AIC_Smaller_is_Better_Trend AICC_Smaller_is_Better_Trend BIC_Smaller_is_Better_Trend CAIC_smaller_is_better_Trend HQIC_smaller_is_better_Trend;
					%end;
				%end;
				%else %if (%upcase(&TraitType)=BINARY and &kmodel=1) %then %do;
					%if %upcase(&GMethod)=RSPL or %upcase(&GMethod)=RMPL %then %do;
						%let Group1OverlayVars= &Group1OverlayVars _2_Res_Log_Pseud_Likel_Trend;
						%let Group2OverlayVars= &Group2OverlayVars Generalized_ChiSquare_Trend;
						%let Group3OverlayVars= &Group3OverlayVars Gener_ChiSq_DF_Ratio_Trend;
					%end;
					%else %if %upcase(&GMethod)=MSPL or %upcase(&GMethod)=MMPL %then %do;
						%let Group1OverlayVars= &Group1OverlayVars _2_Log_Pseud_Likel_Trend;
						%let Group2OverlayVars= &Group2OverlayVars Generalized_ChiSquare_Trend;
						%let Group3OverlayVars= &Group3OverlayVars Gener_ChiSq_DF_Ratio_Trend;										
					%end;
				%end;
			%end;
			%else %if %index(%upcase(&WhichProc),PHREG) %then %do;
				%let Group1OverlayVars= &Group1OverlayVars _2_LOG_L_Trend AIC_Trend SBC_Trend;
			%end;
			%else %if %index(%upcase(&WhichProc),LOGISTIC) %then %do;
				%let Group1OverlayVars= &Group1OverlayVars AIC_Trend SC_Trend _2_Log_L_Trend;
			%end;
		%end;
		%put PlotFitVars= &PlotFitVars; 
		%put Group1OverlayVars= &Group1OverlayVars; 
		%put Group2OverlayVars= &Group2OverlayVars; 
		%put Group3OverlayVars= &Group3OverlayVars; 
	%end;
	%*put OutputFitStat= &OutputFitStat;		
	/*end: Luciano*/

	%let exiterror=0;
	%global volcanoplot;
	%let volcanoplot = 0;

	%if &kmodel=0 %then %do;
		%global KVars SpeedK;
		%let KVars=;
		%let SpeedK= NO; /*S1139177: Luciano efficiency improvement*/
	%end;

	%if %symexist(Listing)=0 %then %let Listing=NO;
	%if %symexist(OutputResid)=0 %then %let OutputResid=NO;
	%if %symexist(OutputPred)=0 %then %let OutputPred=NO;
	%if %symexist(OutputSurvFunc)=0 %then %let OutputSurvFunc=NO;

	data ta_all;
		length Effect $32;
	 delete;
	run;

	%if %Upcase(&Odds)=YES  %then %do; 
		data or_all;
			delete;
		run;
	%end;

	data ma_a;
		length Effect $32;
	  delete;
	run;

	data pag_all;
		length &EffName Trait $32;
		delete;
	run;

	data pat_all;
		length &EffName Trait $32;
		delete;
	run;

	data cpg_all;
		length Trait $32;
		delete;
	run;

	data cpt_all;
		length Trait $32;
		delete;
	run;

	data sfg_all;
		length Trait $32;
		delete;
	run;

	data sft_all;
		length Trait $32;
		delete;
	run;

	%if %upcase(&OutputResid)=YES or %upcase(&OutputPred)=YES %then %do;
		data outresg_all;
			length _Trait_ $32;
			delete;
		run;

		data outrest_all;
			length _Trait_ $32;
			delete;
		run;
	%end;

	%if &survey=1 %then %do;
		data rs_all;
			delete;
		run;
	%end;

	%if &lsm=1 %then %do;
		data outlsm_all;
			length Trait $32 Effect $17;
			delete;
		run;
	%end;

	%if &imputed=0 %then %do;
		data a1;
			set &ds(obs=1);
		run;

		proc transpose data=a1 out=at;
			var &TraitVar;
		run;

		%if &syserr>4 %then %do;
			%let exiterror=1;
			%goto exitm;
		%end;

		%NObsVars(at);
		%global NTrait;
		%let Ntrait = &nobs;
		%if &NTrait=0 %then %do;
			%let exiterror=1;
			%put ERROR: No variables found matching the Trait Variables specified.;
			%goto exitm;
		%end;
		%if &NTrait > 1 %then %let OutputSurvFunc = NO;

		%do i=1 %to &Ntrait; 
			%global _tv&i;
		%end; 

		proc sort data=at;
			by _name_;
		run;

		data _null_;
			set at;
			length is $16;
			is = "_tv" || strip(_n_);
			call symput(is,strip(_name_));
		run;

	%end;

	%let FixedEffVars = ;
	%let i = 1;
	%do %while(%length(%scan(&FixedEff,&i,'*| ')));
		%let FixedEffVars = &FixedEffVars %scan(&FixedEff,&i,'*| ');
		%let i=%eval(&i+1);
	%end;

	%let RandEffVars = ;
	%let i = 1;
	%do %while(%length(%scan(&RandEff,&i,'*| ')));
		%let RandEffVars = &RandEffVars %scan(&RandEff,&i,'*| ');
		%let i=%eval(&i+1);
	%end;

	%if %length(&WhereStmt) %then %do;
		data sub;
			set &ds;
			where &WhereStmt;
		run;

		%if &syserr>4 %then %do;
			%let exiterror=1;
			%goto exitm;
		%end;

		%Nobsvars(sub);
		%if &nobs=0 %then %do;
			%put ERROR: There are no observations in the input data set that meet the criteria in the Where Clause.;
			%let exiterror=1;
			%goto exitm;
		%end;	
		%let ds=sub;
	%end;
	%else %Nobsvars(&ds);

	%if &kmodel=1 %then %do;
		%if (%length(&PedID)=0 and %upcase(&CompressedK)=NO) %then %do;
			data _null_;
				set &ds(obs=1);
				array ks{*} &KVars;
				call symputx("NumKVars",dim(ks));
			run;

			%if &nobs ne &NumKVars %then %do;
				%put ERROR: The number of columns in the K Matrix must be the same as the number of observations in the input data set.;
				%let exiterror=1;
				%goto exitm;
			%end;
		%end;
	%end;

	%if &i>1 %then %do;
		/* If just one random effect variable, use alternative random statement */
		%if &i=2 and %length(&RandOpts)=0 and %length(&ParmsStmt)=0 and %index(&RandEffVars,%str(-))=0 %then %do;

			proc sort data=&ds out=dssort;
				by &ByVars &RandEffVars;
			run;
						
			/*
			%if %length(&KVars) %then %do;
				proc transpose data=dssort out=dssort_t0 prefix= _kv_;
					var &KVars;
				run;

				data dssort_t1;
					merge &ds(keep= &ByVars &RandEffVars) dssort_t0(keep= _kv_:);
				run;

				proc sort data=dssort_t1 out=dssort_t2;
					by &ByVars &RandEffVars;
				run;	
				
				proc transpose data=dssort_t2 out=dssort_t3 prefix= _kv_;
					var _kv_:;
				run;
				
				data dssort_k_all;
					merge dssort(drop= &KVars) dssort_t3(keep= _kv_:);
				run;
				
				data dssort;
					set dssort_k_all;
				run; 
				%let KVars= _kv_:;
			%end;
			*/
			
			%if %index(%upcase(&ClassVars),%upcase(&RandEffVars))>0 %then %do;
				%let NumRandEff = %trim(%substr(&RandEffVars,1,28)_num);
				data numrandeff;
					set dssort;
					by &ByVars &RandEffVars;
					if first.&RandEffVars then &NumRandEff+1;
				run;

				%let ClassVars = %sysfunc(tranwrd(%upcase(&ClassVars),%upcase(&RandEffVars),%str()));
				%let RandEffVars = &NumRandEff;
				%let ds = numrandeff;
			%end;
			%else %let ds=dssort;	
			%if &imputed=1 %then %do;
				/* Need ds to be genotypes since not running %CreateStackedNumeric below */
				proc datasets nolist;
					delete genotypes;
					change &ds=genotypes;
				quit;
				%let ds=genotypes;
			%end;
			%let RandEff = %str(intercept / subject=&RandEffVars);
		%end;
		%else %do;
			%let foundsub=0;
			%let RandEff = %str(&RandEff / &RandOpts);
			/* Need to see if there's a SUBJECT= variable that needs to be kept */
			%let subind=%index(&RandOpts,sub=)+4;
			%if &subind=4 %then %do;
				%let subind=%index(&RandOpts,subject=)+8;
				%if &subind>8 %then %let foundsub=1;
			%end;
			%else %let foundsub=1;
			%if &foundsub=1 %then %let RandEffVars = &RandEffVars %scan(%substr(&RandOpts,&subind),1);
		%end;
	%end;

	%let IntEffVars=;
	%let i = 1;
	%do %while(%length(%scan(&IntEff,&i,'* ')));
		%let IntEffVars = &IntEffVars %scan(&IntEff,&i,'* ');
		%let i=%eval(&i+1);
	%end;

	%let IntEffBuild=;
	%let i = 1;
	%do %while(%length(%scan(&IntEff,&i,' ')));
		%let IntEffBuild = &IntEffBuild Genotype*%scan(&IntEff,&i,' ');
		%let i=%eval(&i+1);
	%end;
	%let NumInt = &i;

	%if &syserr>4 %then %do;
		%let exiterror=1;
		%goto exitm;
	%end;
	
	/*begin S1206799: Luciano added this check to verify that when class variables are specified, they are specified at least
	in one of the effects model: fixed, random, or interaction.*/
	%let ClassVarsTmp= &ClassVars;
	%if %symexist(TraitVar) %then %do;
		%if %length(&TraitVar) %then %do;
			%let ClassVarsTmp= %sysfunc(tranwrd(%upcase(&ClassVarsTmp), %upcase(&TraitVar), %str()));
		%end;
	%end;

	%if %symexist(PedID) %then %do;
		%if %length(&PedID) %then %do;
			%let ClassVarsTmp= %sysfunc(tranwrd(%upcase(&ClassVarsTmp), %upcase(&PedID), %str()));
		%end;
	%end;
	
	%put ClassVarsTmp= &ClassVarsTmp;
	
	%let NeedConstant=0;
	%if %length(&ClassVarsTmp) = 0 %then %do;
		/* Need to do this for Proc Logistic/Surveylogistic/PHREG so it will produce Type3 
		table for Trend test when no Class var is present*/
		%if (%index(&WhichProc,%str(LOGISTIC))>0 or %upcase(&WhichPROC)=%str(PHREG)) %then %do;
			%let NeedConstant=1;
		%end;
		%else 
			%let NeedConstant=0;
	%end;
	%else %if %length(&ClassVarsTmp) %then %do;
	
		/*Checking if ClassVars have been included into any of the variables that goes into the model statement*/
		%let FixRandEffVars= &FixedEffVars &RandEffVars &IntEffVars;
		%put FixRandEffVars= &FixRandEffVars;		
		
		%let j=1;
		%do %while(%length(%scan(&ClassVarsTmp, &j, %str( ))));
			%let j= %sysevalf(&j + 1);
			%let currclass= %scan(&ClassVarsTmp, &j, %str( ));
		%end;
		%let ncin= %sysevalf(&j - 1);
		
		%macro CheckClassVars();
			%global ncout ClassVarsOut FoundAtLeastOne_flag;
			%let ncout= 0;
			%let ClassVarsOut= ;
			%let FoundAtLeastOne_flag= 0;
			
			%let FixRandEffVarsOrig= &FixRandEffVars;
			
			%if %length(&FixRandEffVars) = 0 %then %do;
				%let ClassVarsOut= &ClassVarsTmp;
				%let FoundAtLeastOne_flag= 0;
			%end;		
			%else %do;
				%let j=1;
				%let currclass= %scan(&ClassVarsTmp, &j, %str( ));
				%do %while(%length(&currclass));
					%put currclass= &currclass;
					%let k=1;
					%let currvar= %scan(&FixRandEffVars, &k, %str( ));
					%if %length(&currvar) %then %do;
						%let CandidateClassVarOut= ;
						%let found_flag= 0;
						%do %while(%length(&currvar));
							%put &currclass &currvar;
							%if %upcase(&currclass) = %upcase(&currvar) %then %do;
								%*put YES;
								%let found_flag= 1;
								%let FoundAtLeastOne_flag= 1;
								%let FixRandEffVarsTmp=;
								%let l=1;
								%let currvartmp= %scan(&FixRandEffVars, &l, %str( ));
								%do %while(%length(&currvartmp));
									%if &l ^= &k %then %do;
										%let FixRandEffVarsTmp= &FixRandEffVarsTmp &currvartmp;
									%end;
									%let l= %sysevalf(&l + 1);
									%let currvartmp= %scan(&FixRandEffVars, &l, %str( ));
								%end;
								%let FixRandEffVars= &FixRandEffVarsTmp;
								%goto nextclassvar;
							%end;
							%else %do;
								%*put NO;
								%let CandidateClassVarOut= &currclass;
							%end;

							%let k= %sysevalf(&k + 1);
							%let currvar= %scan(&FixRandEffVars, &k, %str( ));
						%end;

						%if &found_flag = 0 %then %do;
							%let ClassVarsOut= &ClassVarsOut &CandidateClassVarOut;
						%end;
					%end;
					%else %do;
						%let ClassVarsOut= &ClassVarsOut &currclass;
					%end;

					%nextclassvar:;
					%let j= %sysevalf(&j + 1);
					%let currclass= %scan(&ClassVarsTmp, &j, %str( ));
				%end;
				%let FixRandEffVars= &FixRandEffVarsOrig;
				%put ClassVarsOut= &ClassVarsOut;
				%put FixRandEffVars= &FixRandEffVars;
			%end;

			%if %length(&ClassVarsOut) > 0 %then %do;
				%let ncout=1;
				%do %while(%length(%scan(&ClassVarsOut, &ncout, %str( ))));
					%let ncout= %sysevalf(&ncout + 1);
				%end;
				%let ncout= %sysevalf(&ncout - 1);
			%end;
		%mend CheckClassVars;
		%CheckClassVars();

		%put ncout= &ncout;
		%if &ncout %then %do;
			%if &ncout = 1 %then %do;
				%let ErrString0= Class Variable &ClassVarsOut has neither been specified as fixed, random nor interaction effect. Please, review the Model Variables Tab.;
			%end;
			%else %if &ncout > 1 %then %do;
				%let ErrString0= Class Variables &ClassVarsOut have neither been specified as fixed, random nor interaction effects. Please, review the Model Variables Tab.;
			%end;
			
			%if %length(&ProcessName) > 22 %then %do;
				%let ProcessNameShort= %substr(&ProcessName, 1, 22);
			%end;
			%else %do;
				%let ProcessNameShort= &ProcessName;
			%end;

			%let SNPTraitAssocMacro_ScErr0= &ProcessNameShort._ScErr;
			%*put ScriptErr= &SNPTraitAssocMacro_ScErr0;
			%global &SNPTraitAssocMacro_ScErr0;
			%PrepOutFile(&SNPTraitAssocMacro_ScErr0,&SNPTraitAssocMacro_ScErr0.Name,saserror.jsl);
			%*put ScriptErr= &&&SNPTraitAssocMacro_ScErr0;
			%*put ScriptErrName= &&&SNPTraitAssocMacro_ScErr0.Name;

			data _null_;
				file "&&&SNPTraitAssocMacro_ScErr0" lrecl=32767 ;
				put '//!' ;
				put "Names Default to Here(1);" ;
				put "new Window(""ERROR running &FullAPName.""," ;
				put "vlb=VListBox(" ; 
				put "textBox(""The following SAS error ocurred in process &FullAPName:""),";
				put "errtxt = TextEditBox(""\!N""||""";
				put "&ErrString0";
				put """||""\!N"",WhiteBoxStyle(0)),";
				put "errtxt << Font Color(3)," ; 
				put "errtxt << Set Wrap(1000)," ;
				/*put "TextBox(""Please refer to the SAS log displayed in the JMP log window for further details.\!N\!N""),";*/
				put ")" ;
				put ");";
			run;
			%*PackageInsertFile(jsl code from &ProcessName, &OutPath, &&&SNPTraitAssocMacro_ScErr0.Name, no, no, yes);

			%put ERROR: &ErrString0;
			%let exiterror=1;
			%goto exitm;
		%end;
		
		%if (%index(&WhichProc,%str(LOGISTIC))>0 or %upcase(&WhichPROC)=%str(PHREG)) %then %do;
			/* Need to do this for Proc Logistic/Surveylogistic/PHREG so it will produce Type3 
			table for Trend test when no Class var is neither included as fixed nor random effect*/
			%let FixRandEffVars= &FixedEffVars &RandEffVars;
			%put FixRandEffVars0= &FixRandEffVars;
			%CheckClassVars();
			%put FoundAtLeastOne_flag= &FoundAtLeastOne_flag;
			%if &FoundAtLeastOne_flag = 0 %then %do;
				%let NeedConstant=1;
			%end;
			%else %do;
				%let NeedConstant=0;
			%end;
		%end;
	%end;
	%put NeedConstant= &NeedConstant;
	/*end S1206799: Luciano added this check to verify that when class variables are specified, they are specified at least
	in one of the effects model: fixed, random, or interaction.*/

	*begin: S1139177 Luciano efficiency improvement*;
	/*%let AllVars= &ByVarsOnly &TraitVar &ClassVars &FixedEffVars &RandEffVars &IntEffVars &StrataVars &CensorVar &KVars;*/
	%let AllVars= &ByVarsOnly &TraitVar &ClassVars &FixedEffVars &RandEffVars &IntEffVars &StrataVars &CensorVar &selMarkerVars_g &selMarkerVars_t &selFixedEff_g &selFixedEff_t;
	%let ExtraClassVars= ;
	%if &kmodel=1 and %upcase(&SpeedK)=YES %then %do;
		/*Removing KVars from the list of AllVars and creating a data set to hold just KVars. This will make a tremendous
		reduction in terms of file size (bites) when data sets are stacked on top of each other for the proc mixed run.
		Create a data set to hold the KVars (K matrix) and use it in the ldata option of proc mixed on a repeated statement.
		The PredMacro macro for Ridge Regression uses this trick when sample size is less than number of parameters (n < p). 
		However, if prediction is intended, one have to use IML code do get the EBLUP into the the prediction as done also 
		in the PredMacro macro for RidgeRegression.
		*/
		
		/*Because the expected input KVars are in fact square root variables, we need to reconstruct the original K matrix
		for the repeated statement in proc mixed.*/
		data sqrtKmat;
			set &ds(keep=&KVars);
		run;
	
		proc iml;
			use sqrtKmat;
			read all var _num_ into sqrt;
			Kmt= sqrt*sqrt`;
			create Kmat from Kmt;
			append from Kmt; 
		quit;
		
		/*The ldata option from the repeated statement requires columns named parm and row. 
		Also, KVars must be renamed to col1-coln*/
		data Kmat;
			set Kmat;
			parm = 1; 
			row = _n_;
			_IndivID_= _n_; /*needs this to stack matrices using proc sql in downstream code*/
		run;
		/*data outlib.Kmat; set Kmat; run;*/
				
		%let ExtraClassVars= &ExtraClassVars _IndivID_;	
	%end;	
	%else %do;
		%let AllVars= &AllVars &KVars;
	%end;
	*end: S1139177 Luciano efficiency improvement*;	
	%if &survey=1 %then %let AllVars = &AllVars &WeightVar &ClusterVars;

	%global two;
	%let two=minor;
	%if %symexist(RecodeAllele) %then %do;
		%if %index(&RecodeAllele,Major)>0 %then %let two=major;
	%end;
	%if %upcase(&ProcessName) = QTLSINGLEMARKERANALYSIS %then %let two = P2;

	/* Need to set to 3 for analysis part that's blocked - switch back below */
	%if &imputed=1 %then %do;
		%let nummark_orig=&nummark;
		%if %length(&Avar3)=0 %then %let nummark=2;
		%else %let nummark=3;
		%let GenoCol=1;
		/* Don't do calcs for genotype test in this macro */
		%let old_geno=&geno;
		%let geno=0;
	%end;

	%if &snpsnp=1 %then %do;
		data genotypes;
			set &ds end=_close_;
			array _mvars{*} &AlleleVars;
			retain _pairds_;
			if _n_=1 then _pairds_=open("allpairs","i");

			do p=1 to &NPairs;
				rc=fetchobs(_pairds_,p);
				_order_ = p;
				Marker1 = getvarn(_pairds_,1);
				Marker2 = getvarn(_pairds_,2);
				Geno1 = _mvars{Marker1};
				Geno2 = _mvars{Marker2};
				output;
			end;

			if _close_ then rc=close(_pairds_);
			keep &AllVars Geno1 Geno2 _order_;
		run;

		%if &syserr>4 %then %do;
			%let exiterror=1;
			%goto exitm;
		%end;

		proc sort data=genotypes overwrite;
			by _order_;
		run;	
		%let nummark=1;

	%end;

	%let n2snps=%eval(2*&nummark);
					
	%if &imputed=0 and &snpsnp=0 %then %do;
		*begin: S1139177 Luciano efficiency improvement*;
		%let BlockSize = %sysfunc(min(100000,%sysevalf(35000000/&nobs,floor))); 
		%if &kmodel=1 %then %do;
			%let BlockSize = %sysfunc(min(10000,%sysevalf(35000000/&nobs,floor)));
		%end;
		*end: S1139177 Luciano efficiency improvement*;
		%if &nummark < &BlockSize %then %let BlockSize=&nummark;
	%end;
	/* Don't want to do blocking for Imputed SNP-Trait or SNP-SNP */
	%else %let BlockSize = &nummark;
	
	%if &GetNumGeno %then %let BlockSize = &nummark;

	%if %symexist(PerfPerm)=0 %then %let PerfPerm = 0;
	%else %if %length(&PerfPerm)=0 %then %let PerfPerm = 0;
		
	%if &imputed=0 and &snpsnp=0 %then %do;
		/* Merge covariate/traits into stacked data set */
		*begin: S1139177 Luciano efficiency improvement -- using proc sql. No need for data set traits1*;
		*Also, traits and &ds data sets must have a columns of ones (_one_) for the subject option of the repeated statement of proc mixed*;
		/*
		data traits(keep=&AllVars _IndivID_) traits1(keep=&AllVars _IndivID_) 
			%if (%upcase(&OutputResid)=YES or %upcase(&OutputPred)=YES) %then othervars(drop=&ClassVars &FixedEffVars &RandEffVars &IntEffVars &StrataVars &CensorVar &KVars);;
			set &ds end=_last_;
			_IndivID_=_n_;
		run;
		*/
		
		%if &kmodel=1 and %upcase(&SpeedK)=YES %then %do;
			data traits(keep=&AllVars _IndivID_ _one_) 
				%if (%upcase(&OutputResid)=YES or %upcase(&OutputPred)=YES) %then othervars(drop=&ClassVars &FixedEffVars &RandEffVars &IntEffVars &StrataVars &CensorVar &KVars &selMarkerVars_g &selMarkerVars_t &selFixedEff_g &selFixedEff_t);;
				set &ds end=_last_;
				_IndivID_=_n_;
				_one_= 1;
			run;
		%end;
		%else %do;
			data traits(keep=&AllVars _IndivID_) 
				%if (%upcase(&OutputResid)=YES or %upcase(&OutputPred)=YES) %then othervars(drop=&ClassVars &FixedEffVars &RandEffVars &IntEffVars &StrataVars &CensorVar &KVars &selMarkerVars_g &selMarkerVars_t &selFixedEff_g &selFixedEff_t);;
				set &ds end=_last_;
				_IndivID_=_n_;
			run;
		%end;
		*end: S1139177 Luciano efficiency improvement -- using proc sql. No need for traits1*;

		%if &PerfPerm %then %do;
			proc plan %if %length(&Seed) %then seed=&Seed;;
				factors perm=&PerfPerm ordered obs=&nobs random/ noprint;
				output out=perms;
			run;

			data %do p=1 %to &PerfPerm; traits_p&p traits_po&p %end;;
				set perms;
				by perm notsorted;
				set traits point=obs;
				if first.perm then newid=1;
				else newid+1;
				if perm=1 then output traits_p1 traits_po1;
				%do p=2 %to &PerfPerm;
					else if perm=&p then output traits_p&p traits_po&p;
				%end;
			run;

		%end;
		
		*begin: S1139177 Luciano efficiency improvement -- using proc sql in downstream code*;
		/*
		options nonotes;
		proc datasets nolist;
			%do i=2 %to &BlockSize;
				append base=traits data=traits1;
			%end;
		quit;
		options notes;	
		*/
		/*
		%put BlockSizeLuc= &BlockSize;
		data outlib.traits; set traits; run; 
		data outlib.traits1; set traits1; run;
		*/
		*end: S1139177 Luciano efficiency improvement -- using proc sql in downstream code*;
		
	%end;

	%if &imputed=0 and &snpsnp=0 %then %do;
		%let first = 1;
		%let last=&BlockSize;

		data _null_;
			set &ds(obs=1);
			array getname{*} &AlleleVars;
			%let Block=1;
			%do %until (&first > &nummark);	
				%if %length(&GenoCol) %then %do;
					_f = vname(getname(&first));
					_l = vname(getname(&last));
				%end;
				%else %do;
					_f = vname(getname(%eval(2*&first-1)));
					_l = vname(getname(%eval(2*&last)));
				%end;

				call symput("firstvar&Block",_f);
				call symput("lastvar&Block",_l);

				%global BlockStart&Block BlockEnd&Block;
				%let BlockStart&Block = &first;
				%let BlockEnd&Block = &last;

				%let first = %eval(&last + 1);
				%let last = %eval(&first + &BlockSize - 1);
				%let Block = %eval(&Block + 1);
				%if &last > &nummark %then %let last = &nummark;
			%end;
		run;	
		%let NBlocks = %eval(&Block - 1);

	%end;
	%else %let NBlocks = 1;

	%let first = 1;
	%let last=&BlockSize;
	%let Block = 1;

	%put Number of Blocks = &NBlocks, Block Size = &BlockSize;

	%if &imputed=0 and &snpsnp=0 %then %do;
		/*begin: Defect S1046837. Luciano;*/
		/*
		data %do b=1 %to &NBlocks; avars&b(keep=&&firstvar&b--&&lastvar&b) %end;;
			set &ds(keep=&AlleleVars);
		run;
		*/
		
		%do b=1 %to &NBlocks; 
			data avars&b(keep=&&firstvar&b--&&lastvar&b);
				set &ds(keep=&AlleleVars);
			run;
			
			%NObsVars(avars&b);
			%if &nvars < 1 %then %do;
				%let string1= Order of SNP variables specified in the SNP Variables field do not match order of SNP variables in the list of Available Variables field.;
				%let string2= Please, goto the General tab and change the order of marker variables in the SNP Variables field.;  
				%put ERROR: &string1.. &string2; 
				%let exiterror=1;
				%goto exitm;
			%end;
		%end;
		/*end: Luciano;*/	
	%end;

	options DKROCOND=nowarn;

	%let Genotype=Genotype;
	%if &snpsnp=1 %then %do;
		%let Genotype=%str(Geno1*Geno2);
		%let FixedEff = %quote(&FixedEff) Geno1 Geno2;
	%end;

	%let OutputMajAllele=0;
	%do p=0 %to &PerfPerm;

		data ma_p;
			length Effect $32;
			delete;
		run;

		data ta_p;
			length Effect $32;
			delete;
		run;

		%if &p>0 %then %do;
			options nonotes;

			proc datasets nolist;
				%do i=2 %to &BlockSize;
					append base=traits_p&p data=traits_po&p;
				%end;
			quit;
			options notes;
		%end;

		%do %until (&first > &nummark);

			%if &p = 0 %then %do;

				%put Currently processing block &Block.;

				%if &imputed=0 and &snpsnp=0 %then %do;
					%CreateStackedNumericDS(avars&block,_2=&two,_del=0);
					%if &exiterr=1 %then %do;
						%let exiterror=1;
						%goto exitm;
					%end;	

					proc datasets nolist;
						delete avars&block genotypes;
					quit;
					
					%if &GetNumGeno %then %do;					
						data trans(keep=_name_);
							set trans;
						run;	
						
						proc datasets nolist;
							delete genotypes;
						quit;
						
						%if ^&GetCovParms %then %goto exitm;
						%else %goto Skip0;
					%end;
					
					*begin: S1139177 Luciano efficiency improvement -- using proc sql*;
					proc datasets nolist;
						delete trans;
					quit;
						
					data NumGenoData;
						set NumGenoData;
						by _order_;
						if first._order_ then _indIDtmp_= 1;
						else _indIDtmp_ = _indIDtmp_ + 1;
						retain _indIDtmp_;
					run;	
					
					proc sort data= NumGenoData overwrite;
						by _IndIDtmp_;
					run;
					
					proc sort data= traits overwrite;
						by _IndivID_;
					run;
					
					data genotypes;
						merge NumGenoData(rename= (_indIDtmp_= _IndivID_)) traits;
						by _IndivID_;
						**S1180797: snp trait association results changed from version 7.0 to 8.0**;
						%if &two=%str(major) %then %do;
							Genotype = 2 - Genotype;
						%end;
					run;
					
					proc sort data= genotypes overwrite;
						by _order_ 
						%if %symexist(OutputMajAllele) %then %do;
							%if &OutputMajAllele %then %do;
								MajorAllele
							%end;
						%end;
						%if %symexist(ByVars) %then %do;
							%if %length(&ByVars) %then %do;
								&ByVars
							%end;
						%end;
						;
					run;
						
					/*
					proc sql UNDO_POLICY=NONE;
						create table genotypes(drop=_IndIDtmp_) as 
						select b.*, a.*
						from NumGenoData as a 
						left join traits as b
						on a._IndIDtmp_= b._IndivID_
						order by _order_
						%if %symexist(OutputMajAllele) %then %do;
							%if &OutputMajAllele %then %do;
								,MajorAllele
							%end;
						%end;
						%if %symexist(ByVars) %then %do;
							%if %length(&ByVars) %then %do;
								,&ByVars
							%end;
						%end;
						;
					quit;
					*/
					
					%if &PerfPerm %then %do;
						**S1180797: snp trait association results changed from version 7.0 to 8.0**;
						proc sort data= NumGenoData overwrite;
							by _order_ 
							%if %symexist(OutputMajAllele) %then %do;
								%if &OutputMajAllele %then %do;
									MajorAllele
								%end;
							%end;
							%if %symexist(ByVars) %then %do;
								%if %length(&ByVars) %then %do;
									&ByVars
								%end;
							%end;
							;
						run;
					%end;
					%else %do;
						proc datasets nolist;
							delete NumGenoData;
						quit;					
					%end;
					*end: S1139177 Luciano efficiency improvement -- using proc sql*;	
				
					*begin: S1139177 Luciano efficiency improvement -- stacking K matrices*;
					%if &kmodel=1 and %upcase(&SpeedK)=YES %then %do;
						proc sql UNDO_POLICY=NONE;
							create table Kmats(drop=_IndIDtmp_) as 
							select b.*, a.*
							from genotypes(keep=_IndivID_ _order_ 
									%if %symexist(OutputMajAllele) %then %do;
										%if &OutputMajAllele %then MajorAllele; 
									%end;
									%if %symexist(ByVars) %then %do;
										&ByVars
									%end;
									) as a 
							left join Kmat(rename=(_IndivID_=_IndIDtmp_)) as b
							on a._IndivID_= b._IndIDtmp_;
						quit;
					
						proc sort data=Kmats overwrite; 
							by _order_ 
							%if %symexist(OutputMajAllele) %then %do;
								%if &OutputMajAllele %then MajorAllele; 
							%end;
							%if %symexist(ByVars) %then %do;
								&ByVars
							%end;
							;
						run;						
					%end;
					*end: S1139177 Luciano efficiency improvement -- stacking K matrices*;
				%end;
				
				/* For Survey SNP-Trait, if RATE or TOTAL option is set to a data set */
				%if &survey=1 %then %do;
					%if &block=1 %then %let rtorig=%quote(&RateTotal);

					%if %index(%upcase(&rtorig),%str(INLIB))>0 %then %do;;
						%if %length(&RateOption) %then %let RateTotal = %quote(RATE=ratetotal);
						%else %if %length(&TotalOption) %then %let RateTotal = %quote(TOTAL=ratetotal);	

						data ratetotal;
							set %do i=&first %to &last; %scan(&rtorig,2,%str(=))(in=in&i) %end;;
							if in&first=1 then _order_=&first;
							%do i=%eval(&first+1) %to &last; 
								else if in&i=1 then _order_=&i;
							%end;
						run;
						%if &syserr>4 %then %do;
							%let exiterror=1;
							%goto exitm;
						%end;
					%end;
				%end;

			%end;
			%else %do;
				/* using permuted trait data */
						
				*begin: S1139177 Luciano efficiency improvement -- using proc sql*;
				data genotypes;
					set traits_p&p; set NumGenoData;
					%if &two=%str(major) %then %do;
						Genotype = 2 - Genotype;
					%end;
				run;
				
				/*
				proc sql UNDO_POLICY=NONE;
					create table genotypes(drop=_IndIDtmp_) as 
					select b.*, a.*
					from NumGenoData as a 
					left join traits_p&p as b
					on a._IndIDtmp_= b._IndivID_;
				quit;
				*/
				
				proc sort data=genotypes overwrite; 
					by _order_ %if &OutputMajAllele %then MajorAllele; &ByVars;
				run;
				*end: S1139177 Luciano efficiency improvement -- using proc sql*;							
			%end;

			/* Need to do this for Proc Logistic/Surveylogistic/PHREG so it will produce Type3
			table for Trend test when no Class var is present or no Class var is included neither
			as fixed nor random effect*/
			/*%if (%index(&WhichProc,%str(LOGISTIC))>0 or %upcase(&WhichPROC)=%str(PHREG)) and %length(&ClassVars)=0 %then %do;*/
			%if (%index(&WhichProc,%str(LOGISTIC))>0 or %upcase(&WhichPROC)=%str(PHREG)) %then %do;
				%if &NeedConstant %then %do;
					data genotypes;
						retain constant 0;
						set genotypes;
					run;
					/*%let NeedConstant=1;*/
				%end;
			%end;
			/*%else %let NeedConstant=0;*/
			%*put NeedConstant= &NeedConstant;
			
			%Skip0:;
			
			/*data OutLib.Genotypes&two; set Genotypes; run;*/
			
			%do t=1 %to &NTrait;

				%let TraitVar  = &&_tv&t;

				%let ie=0;
				%let Interaction=;

				%if %upcase(&IntTestsOnly)=YES %then %do;
					%let ie=1;
					%let Interaction=%scan(&IntEffBuild,&ie,' ');
				%end;

				%do %until(%length(%scan(&IntEffBuild,&ie,' '))=0);

					title "Trait &TraitVar";
					options nonotes;

					%if %upcase(&Listing)=NO %then %do;
						ods listing close;
					%end;	
									
					%if (&geno=1) %then %do;
					
						/*S1141184: Fix Covariance Parameter was not working when Trend test was selected alone*/
						%if %symexist(FixCovParms) %then %do;
							/*S1352791: removing &Block=1 to fix QK Mixed Model with wrong values for FValue_Genotype*/
							%if %upcase(&FixCovParms)=YES and &p=0 /*and &Block=1*/ and (%length(&KVars) or %length(&RandEff)) %then %do;
								%if %upcase(&Listing)=YES %then %do;
									ods listing close;
								%end;	
								ods output CovParms = fixcp;
								%if &kmodel=1 and %upcase(&SpeedK)=YES %then %do;
									proc &WhichProc data=traits &ProcOption ;
								%end;
								%else %do;
									proc &WhichProc data=&ds(drop=&AlleleVars) &ProcOption ;
								%end;

									*begin: S1139177 Luciano efficiency improvement*;
									*class &ClassVars  &ClassOpt;
									*class &ClassVars &ExtraClassVars &ClassOpt;
									class &ClassVars &ExtraClassVars &selMarkerVars_g &ClassOpt;
									*end: S1139177 Luciano efficiency improvement*;

									*model &TraitVar &TraitOpt = &FixedEff &ModOption;
									*model &TraitVar &TraitOpt = &FixedEff &selFixedEff_g &ModOption;
									%put FixG= &FixedEff &selFixedEff_g &selMarkerVars_g;
									model &TraitVar &TraitOpt = &FixedEff &selFixedEff_g &selMarkerVars_g &ModOption;

									%if &kmodel=1 %then %do;
										*begin: S1139177 Luciano efficiency improvement*;
										%if %upcase(&SpeedK)=YES %then %do;
											repeated _IndivID_ / type=lin(1) ldata=Kmat subject=_one_ local;
										%end;
										%else %do;
											random &KVars / type=toep(1) %if %length(&PedID) %then subject=&PedID;;
										%end;
										*end: S1139177 Luciano efficiency improvement*;
									%end;

									%if %length(&RandEff)>0 %then %do;
										random &RandEff %if %upcase(&TraitType)=NOMINAL %then group=&TraitVar;;
									%end;
									/* kemicl remove to avoid fixing parameters based on first trait for multiple traits S0987026*/
									/*
									%if %length(&ParmsStmt) %then %do;
										parms &ParmsStmt ;
									%end;
									*/
									*begin: S1139177 Luciano efficiency improvement*;
									%if &kmodel=1 and %upcase(&SpeedK)=YES %then %do;
										parms / lowerb=0;
										ods exclude classlevels;
									%end;
									*end: S1139177 Luciano efficiency improvement*;
								quit;					

								data _null_;
									set fixcp end=_l;
									call symput('varcomp'||strip(_n_),strip(Estimate));
									if _l then call symputx("numcp",_n_);
								run;
								%let ParmsStmt = ;
								%let hold= %str(hold=);

								%do cp=1 %to &numcp;
									%let ParmsStmt = &ParmsStmt &&varcomp&cp;
									%let hold = %quote(&hold &cp,);
								%end;
								%let ParmsStmt = %quote(&ParmsStmt / &hold);

								%if &kmodel=1 and %upcase(&SpeedK)=YES %then %do;
									%let ParmsStmt = &ParmsStmt lowerb=0;
									/*data outlib.traits; set &ds; run;*/
									/*data outlib.Kmat2; set Kmat; run;*/
								%end;
								/*data outlib.fixcp; set fixcp; run;*/
								%put ParmsStmt= &ParmsStmt;
								%let ParmsStmt_g = &ParmsStmt;
																
								%if %upcase(&Listing)=YES %then %do;
									ods listing;
								%end;
								
								%if &GetCovParms %then %do;
									data fixcp_all;
										set fixcp_all fixcp(in=_in);
										if _in then _traitvar_= "&TraitVar";
									run;
									%goto endtrait;
								%end;
							%end;
						%end;	

						data ma; /* kemicl - added to ensure data is not repeated if PROC does not produce estimates */
							delete;
						run;
						
						proc datasets nolist;
							delete outres;
						quit;

						title2 "Genotype Test &Interaction";
						ods output &Gtable=ma
							%if &p=0 %then %do;
								 %if &WhichProc ne SURVEYREG %then %do;
									nobs = mnobs %if &WhichProc ne PHREG %then (where=(Label ? "Observations Used"));
								 %end;
								 &ParmEst=pag 
								%if (&kmodel=1 or %length(&RandEff)) and &covp=1 %then CovParms=cp; 
								%if &lsm=1 and &ie=0 %then lsmeans=lsm diffs=lsd;
								%if %upcase(&TraitType)=BINARY %then responseprofile=rp; 							
								/*begin: Luciano*/
								%if %upcase(&OutputRSquare)=YES and %index(%upcase(&WhichProc),LOGISTIC) %then
									rsquare= grsq;
								/*end: Luciano*/
								%if %upcase(&OutputFitStat)=YES %then 
									FitStatistics= fsg;
							%end;
						;
						
						/*data OutLib.genotypes&block; set genotypes; run;*/
						
						%*let exiterror= 1;
						%*goto exitm;
						
						proc &WhichProc	data=genotypes %if %length(&selmarkervarsorder_g) %then (where=(_order_ not in (%sysfunc(tranwrd(&selmarkervarsorder_g, %str( ), %str(,)))))); &ProcOption %if &survey=1 %then &ratetotal; ;
							*begin: S1139177 Luciano efficiency improvement*;
							*class %sysfunc(translate(&Genotype,%str( ),%str(*))) &ClassVars &ClassOpt;
							*class %sysfunc(translate(&Genotype,%str( ),%str(*))) &ClassVars &ExtraClassVars &ClassOpt;
							class %sysfunc(translate(&Genotype,%str( ),%str(*))) &ClassVars &ExtraClassVars &selMarkerVars_g &ClassOpt;
							*begin: S1139177 Luciano efficiency improvement*;
							
							model &TraitVar &TraitOpt = &FixedEff &selFixedEff_g &selMarkerVars_g &Genotype &Interaction &ModOption;

							%if &kmodel=1 %then %do;
								*begin: S1139177 Luciano efficiency improvement*;
								%if %upcase(&SpeedK)=YES %then %do;
									repeated _IndivID_ / type=lin(1) ldata=Kmats subject=_one_ local;
								%end;
								%else %do;
									random &KVars / type=toep(1) %if %length(&PedID) %then subject=&PedID;;
								%end;
								*end: S1139177 Luciano efficiency improvement*;
							%end;

							%if %length(&RandEff)>0 %then %do;
								random &RandEff %if %upcase(&TraitType)=NOMINAL %then group=&TraitVar;;
							%end;

							%if %length(&ParmsStmt_g) %then %do;
								parms &ParmsStmt_g ;
							%end;

							%if %length(&StrataVars)>0 %then %do;
								strata &StrataVars;
							%end;

							%if &lsm=1 %then %do;
								%if &snpsnp %then %do;
									lsmeans &genotype / diff=control('0' '0');							
								%end;
								%else %do;
									lsmeans &genotype / diff=control('0');
								%end;
							%end;

							%if &survey=1 %then %do;
								%if %length(&ClusterVars) %then %do;
									cluster &ClusterVars;
								%end;
								%if %length(&WeightVar) %then %do;
									weight &WeightVar;
								%end;
							%end;	
							%if (%upcase(&OutputResid)=YES or %upcase(&OutputPred)=YES) and %length(&RandEff) %then %do;
								id _IndivID_ ;
							%end;
							by _order_ %if &OutputMajAllele %then MajorAllele; &ByVars;

							%if %upcase(&OutputSurvFunc)=YES or ((%upcase(&OutputResid)=YES or %upcase(&OutputPred)=YES) and %upcase(&TraitType)=SURVIVAL) %then %do;
								output out=outres
								%if %upcase(&OutputSurvFunc)=YES %then survival=SurvivalFunctionEst;
								%if %upcase(&OutputResid)=YES and %upcase(&TraitType)=SURVIVAL %then resdev=Resid;
								%if %upcase(&OutputPred)=YES and %upcase(&TraitType)=SURVIVAL %then predicted=pred;
							   ;
							%end;
							*begin: S1139177 Luciano efficiency improvement*;
							%if &kmodel=1 and %upcase(&SpeedK)=YES %then 
								ods exclude classlevels;; 
							*end: S1139177 Luciano efficiency improvement*;
						quit;

						options notes;
						
						/*
						%if (&syserr>4) %then %do;
							%let exiterror=1;
							%goto exitm;
						%end;		
						*/
						/* kemicl - added to catch error when all effects are not estimable */			
						%NObsVars(ma);
						%if ^&nobs %then %do;
							%put ERROR:  PROC &WhichProc generated no estimates for the Genotype Test for trait &TraitVar..  There may be excessive missing data or the contrast may be nonestimable. Please see the log for more details.;
							%goto skip1;
						%end;

						%put Test = Genotype, Trait = &TraitVar, Effects = Genotype &Interaction, Permutation = &p;       			/* kemicl - added to put details of run in log */                   

						%if &p=0 %then %do;

							%if %upcase(&TraitType)=BINARY %then %do;
								proc transpose data=rp out=rp(drop=_name_) prefix=NumTrait;
									by _order_ &ByVars;
									var count;
									id %if %index(%upcase(&WhichProc),LOGISTIC) %then Outcome; %else &TraitVar;;
								run;

								%let datatomerge=rp;
							%end;
							%else %let datatomerge=;					

							%if &WhichProc ne SURVEYREG %then %do;
								data ma;
									merge mnobs(keep=_order_ &ByVars nobsused) &datatomerge ma;
									by _order_ &ByVars;
									rename nobsused=SampleSize;
								run;
							%end;

							/*begin: including RSquare for logistic regression. Luciano*/
							%if %upcase(&OutputRSquare)=YES and %index(%upcase(&WhichProc),LOGISTIC) %then %do;
								data ma;
									merge ma grsq(keep= _order_ nValue1 nValue2 %if &OutputMajAllele %then MajorAllele; &ByVars);
									by _order_ %if &OutputMajAllele %then MajorAllele; &ByVars;
									rename nValue1= RSquare_Genotype nValue2=Rescaled_RSquare_Genotype;
								run;					
							%end;
							/*end: Luciano*/
							
							%if %upcase(&OutputFitStat)=YES %then %do;
								%*put WhichProc= &WhichProc;
								/*data OutLib.fsg; set fsg; run;*/
								/*data OutLib.ma; set ma; run;*/
								
								proc transpose data=fsg(
									%if %index(%upcase(&WhichProc),LOGISTIC) %then %do;
										rename=(
											criterion= descr 
											interceptandcovariates= value
										)
									%end;
									%else %if %index(%upcase(&WhichProc),PHREG) %then %do;
										rename=(
											criterion= descr  
											withcovariates= value
										)
									%end;
									)
									out=fsg(drop= _name_); 
									var value;
									id descr;
									by _order_ %if &OutputMajAllele %then MajorAllele; &ByVars;
								run;
								
								/*data OutLib.fsg2; set fsg; run;*/
								
								data ma;
									merge ma fsg;
									by _order_ %if &OutputMajAllele %then MajorAllele; &ByVars;
									rename
									%if %index(%upcase(&WhichProc),MIXED) %then %do;
										_2_Res_Log_Likelihood= _2_Res_Log_Likelihood_Genotype
										AIC__Smaller_is_Better_= AIC_Smaller_is_Better_Genotype
										AICC__Smaller_is_Better_= AICC_Smaller_is_Better_Genotype
										BIC__Smaller_is_Better_= BIC_Smaller_is_Better_Genotype
									%end;
									%else %if %index(%upcase(&WhichProc),GLIMMIX) %then %do;
										%if (%upcase(&TraitType)=COUNT and %length(&RandEff)>0) 
											or (%upcase(&TraitType)=BINARY and %length(&RandEff)>0) %then %do;
											%if %upcase(&GMethod)=RSPL or %upcase(&GMethod)=RMPL %then %do;
												_2_Res_Log_Pseudo_Likelihood= _2_Res_Log_Pseud_Likel_Genotype
												Generalized_Chi_Square= Generalized_ChiSquare_Genotype
												Gener__Chi_Square___DF= Gener_ChiSq_DF_Ratio_Genotype
											%end;
											%else %if %upcase(&GMethod)=MSPL or %upcase(&GMethod)=MMPL %then %do;
												_2_Log_Pseudo_Likelihood= _2_Log_Pseud_Likel_Genotype
												Generalized_Chi_Square= Generalized_ChiSquare_Genotype
												Gener__Chi_Square___DF= Gener_ChiSq_DF_Ratio_Genotype
											%end;
											%else %if %upcase(&GMethod)=QUAD or %upcase(&GMethod)=LAPLACE %then %do;
												_2_Log_Likelihood= _2_Log_Likelihood_Genotype
												AIC___smaller_is_better_= AIC_Smaller_is_Better_Genotype
												AICC__smaller_is_better_= AICC_Smaller_is_Better_Genotype
												BIC___smaller_is_better_= BIC_Smaller_is_Better_Genotype
												CAIC__smaller_is_better_= CAIC_smaller_is_better_Genotype
												HQIC__smaller_is_better_= HQIC_smaller_is_better_Genotype											
											%end;
										%end;
										%else %if %upcase(&TraitType)=COUNT and %length(&RandEff)=0 %then %do; 		
											_2_Log_Likelihood= _2_Log_Likelihood_Genotype
											AIC___smaller_is_better_= AIC_Smaller_is_Better_Genotype
											AICC__smaller_is_better_= AICC_Smaller_is_Better_Genotype
											BIC___smaller_is_better_= BIC_Smaller_is_Better_Genotype
											CAIC__smaller_is_better_= CAIC_smaller_is_better_Genotype
											HQIC__smaller_is_better_= HQIC_smaller_is_better_Genotype
											Pearson_Chi_Square= Pearson_ChiSquare_Genotype
											Pearson_Chi_Square___DF= Pearson_ChiSq_DF_Ratio_Genotype											
										%end;
										%else %if %upcase(&TraitType)=NOMINAL or %upcase(&TraitType)=ORDINAL %then %do;
											%if %upcase(&GMethod)=RSPL or %upcase(&GMethod)=RMPL %then %do;
												_2_Res_Log_Pseudo_Likelihood= _2_Res_Log_Pseud_Likel_Genotype
											%end;
											%else %if %upcase(&GMethod)=MSPL or %upcase(&GMethod)=MMPL %then %do;
												_2_Log_Pseudo_Likelihood= _2_Log_Pseud_Likel_Genotype
											%end;
											%else %if %upcase(&GMethod)=QUAD or %upcase(&GMethod)=LAPLACE %then %do;
												_2_Log_Likelihood= _2_Log_Likelihood_Genotype
												AIC___smaller_is_better_= AIC_Smaller_is_Better_Genotype
												AICC__smaller_is_better_= AICC_Smaller_is_Better_Genotype
												BIC___smaller_is_better_= BIC_Smaller_is_Better_Genotype
												CAIC__smaller_is_better_= CAIC_smaller_is_better_Genotype
												HQIC__smaller_is_better_= HQIC_smaller_is_better_Genotype
											%end;	
										%end;
										%else %if (%upcase(&TraitType)=BINARY and &kmodel=1) %then %do;
											%if %upcase(&GMethod)=RSPL or %upcase(&GMethod)=RMPL %then %do;
												_2_Res_Log_Pseudo_Likelihood= _2_Res_Log_Pseud_Likel_Genotype
												Generalized_Chi_Square= Generalized_ChiSquare_Genotype
												Gener__Chi_Square___DF= Gener_ChiSq_DF_Ratio_Genotype
											%end;
											%else %if %upcase(&GMethod)=MSPL or %upcase(&GMethod)=MMPL %then %do;
												_2_Log_Pseudo_Likelihood= _2_Log_Pseud_Likel_Genotype
												Generalized_Chi_Square= Generalized_ChiSquare_Genotype
												Gener__Chi_Square___DF= Gener_ChiSq_DF_Ratio_Genotype											
											%end;
										%end;										
									%end;
									%else %if %index(%upcase(&WhichProc),PHREG) %then %do;
										_2_LOG_L= _2_LOG_L_Genotype
										AIC= AIC_Genotype
										SBC= SBC_Genotype
									%end;
									%else %if %index(%upcase(&WhichProc),LOGISTIC) %then %do;
										AIC= AIC_Genotype
										SC= SC_Genotype
										_2_Log_L= _2_Log_L_Genotype
									%end;
									;
								run;
							%end;

							data ma_a; 
								length Trait $32;
								set ma_a(in=orig) ma;
								%if &ie>0 %then %do;
									if orig=1 or index(Effect,"Genotype*")>0 or index(Effect,"*Genotype")>0; 
									/* To make sure interactions in same order for Genotype and Trend tests */
									if index(Effect,"Genotype*")>1 then do;
										Effect=cats("Genotype*",tranwrd(Effect,"Genotype*",""));
									end;
									else if index(Effect,"Genotype")>1 then do;
										Effect=cats("Genotype*",tranwrd(Effect,"*Genotype",""));
									end;
								%end;
								%else %do;
									where index(Effect,"&Genotype")>0; 
								%end;
								if not orig then Trait = "&TraitVar";
								label Prob&Stat=' ';
							run;		
							
							%if &pest = 1 %then %do;
								data pag_all;	
									%if %length(&IntEffBuild) %then %do;
										length Interaction $32;
									%end;
									set pag_all(in=orig) pag;
									if orig=0 then do;
										Trait="&TraitVar";
										%if %length(&IntEffBuild) %then %do;
											Interaction="&Interaction";
										%end;
									end;
								run;
							%end;

							%if (%upcase(&OutputResid)=YES or %upcase(&OutputPred)=YES) and &ie=0 %then %do;
							
								/*data outlib.outres; set outres; run;*/

								%if %sysfunc(exist(outres)) %then %do;
									data outresg_all;
										set outresg_all(in=orig) outres;
										if orig=0 then do;
											_Trait_="&TraitVar";
										end;
									run;		
								%end;
							%end;

							%if &lsm=1 and &ie=0 %then %do;
								data outlsm_all;
									set outlsm_all(in=orig) lsm lsd(in=idiff);
									if orig=0 then do;
										diff=0;
										Trait="&TraitVar";
										if idiff then do;
											diff=1;
											%if &snpsnp %then %do;
												Effect = "Diff with (0,0)";										
											%end;
											%else %do;
												Effect = "Diff with 0";
											%end;
										end;

									end;
								run;		
							%end;				

							%if (&kmodel=1 or %length(&RandEff)) and &covp %then %do;
								data cpg_all;
									%if %length(&IntEffBuild) %then %do;
										length Interaction $32;
									%end;					
									set cpg_all(in=orig) cp;
									if orig=0 then do;
										Trait="&TraitVar";
										%if %length(&IntEffBuild) %then %do;
											Interaction="&Interaction";
										%end;
									end;
								run;
							%end;

							%if %upcase(&OutputSurvFunc)=YES %then %do;
								proc sort data=outres out=geno nodupkey;
									by _order_ &genotype;
								run;

								data geno;
									set geno;
									SurvivalFunctionEst=1;
									&TraitVar = 0;
								run;

								data survcurvesg;
									set outres geno;
									if &genotype ne .;
								run;

								data sfg_all;
									%if %length(&IntEffBuild) %then %do;
										length Interaction $32;
									%end;						
									set sfg_all(in=orig) survcurvesg;
									if orig=0 then do;
										Trait="&TraitVar";
										%if %length(&IntEffBuild) %then %do;
											Interaction="&Interaction";
										%end;
									end;
								run;								

							%end;							
						%end; /* end p=0 */
						%else %do;
							data ma_p; 
								length Trait $32;
								set ma_p(in=orig) ma;
								%if &ie>0 %then %do;
									if orig=1 or index(Effect,"Genotype*")>0 or index(Effect,"*Genotype")>0; 
									/* To make sure interactions in same order for Genotype and Trend tests */
									if index(Effect,"Genotype*")>1 then do;
										Effect=cats("Genotype*",tranwrd(Effect,"Genotype*",""));
									end;
									else if index(Effect,"Genotype")>1 then do;
										Effect=cats("Genotype*",tranwrd(Effect,"*Genotype",""));
									end;
								%end;
								%else %do;
									where index(Effect,"&Genotype")>0; 
								%end;
								if not orig then do;
									Trait = "&TraitVar";
									ProbG&p = Prob&Stat;
								end;
								keep _order_ Trait Effect ProbG&p;
							run;
						%end;

					%end;

					%skip1:

					%if &trend=1 %then %do;
					
						/*S1141184: Fix Covariance Parameter was not working when Trend test was selected alone*/
						%if %symexist(FixCovParms) %then %do;
							/*S1352791: removing &Block=1 to fix QK Mixed Model with wrong values for FValue_Genotype*/
							%if %upcase(&FixCovParms)=YES and &p=0 /*and &Block=1*/ and (%length(&KVars) or %length(&RandEff)) %then %do;
								%if %upcase(&Listing)=YES %then %do;
									ods listing close;
								%end;	
								ods output CovParms = fixcp;
								%if &kmodel=1 and %upcase(&SpeedK)=YES %then %do;
									proc &WhichProc data=traits &ProcOption ;
								%end;
								%else %do;
									proc &WhichProc data=&ds(drop=&AlleleVars) &ProcOption ;
								%end;

									*begin: S1139177 Luciano efficiency improvement*;
									*class &ClassVars  &ClassOpt;
									class &ClassVars &ExtraClassVars &ClassOpt;
									*end: S1139177 Luciano efficiency improvement*;

									*model &TraitVar &TraitOpt = &FixedEff &ModOption;
									*model &TraitVar &TraitOpt = &FixedEff &selFixedEff_t &ModOption;
									model &TraitVar &TraitOpt = &FixedEff &selFixedEff_t &selMarkerVars_t &ModOption;

									%if &kmodel=1 %then %do;
										*begin: S1139177 Luciano efficiency improvement*;
										%if %upcase(&SpeedK)=YES %then %do;
											repeated _IndivID_ / type=lin(1) ldata=Kmat subject=_one_ local;
										%end;
										%else %do;
											random &KVars / type=toep(1) %if %length(&PedID) %then subject=&PedID;;
										%end;
										*end: S1139177 Luciano efficiency improvement*;
									%end;

									%if %length(&RandEff)>0 %then %do;
										random &RandEff %if %upcase(&TraitType)=NOMINAL %then group=&TraitVar;;
									%end;
									/* kemicl remove to avoid fixing parameters based on first trait for multiple traits S0987026*/
									/*
									%if %length(&ParmsStmt) %then %do;
										parms &ParmsStmt ;
									%end;
									*/
									*begin: S1139177 Luciano efficiency improvement*;
									%if &kmodel=1 and %upcase(&SpeedK)=YES %then %do;
										parms / lowerb=0;
										ods exclude classlevels;
									%end;
									*end: S1139177 Luciano efficiency improvement*;
								quit;					

								data _null_;
									set fixcp end=_l;
									call symput('varcomp'||strip(_n_),strip(Estimate));
									if _l then call symputx("numcp",_n_);
								run;
								%let ParmsStmt = ;
								%let hold= %str(hold=);

								%do cp=1 %to &numcp;
									%let ParmsStmt = &ParmsStmt &&varcomp&cp;
									%let hold = %quote(&hold &cp,);
								%end;
								%let ParmsStmt = %quote(&ParmsStmt / &hold);

								%if &kmodel=1 and %upcase(&SpeedK)=YES %then %do;
									%let ParmsStmt = &ParmsStmt lowerb=0;
									/*data outlib.traits; set &ds; run;*/
									/*data outlib.Kmat2; set Kmat; run;*/
								%end;
								/*data outlib.fixcp; set fixcp; run;*/
								%put ParmsStmt= &ParmsStmt;
								%let ParmsStmt_t = &ParmsStmt;

								%if %upcase(&Listing)=YES %then %do;
									ods listing;
								%end;	
								
								%if &GetCovParms %then %do;
									data fixcp_all;
										set fixcp_all fixcp(in=_in);
										if _in then _traitvar_= "&TraitVar";
									run;
									%goto endtrait;
								%end;
							%end;
						%end;
						
						data ta; /* kemicl - added to ensure data is not repeated if PROC does not produce estimates */
							delete;
						run;

						%if %Upcase(&Odds)=YES  %then %do; 
							data or;
								delete;
							run;
						%end;

						proc datasets nolist;
							delete outres;
						quit;

						title2 "Trend Test &Interaction";

						options nonotes;
						/*kemicl - Added odds ratio options and Random effect ability with discrete trait. 
						 If Logistic Procedure - enable OddsRatio statement and corresponding ODS output table 
						 If GLIMMIX Procedure - exponentiate estimate from Contrast Statement and retain in ODS output table
						 */
						ods output &Gtable=ta %if &TraitType=SContinuous %then (where=(Effect ? "Genotype")); 
							 %if &p=0 %then %do;
								 &ParmEst = pat
								 %if &WhichProc ne SURVEYREG %then %do;
									nobs = tnobs %if &WhichProc ne PHREG %then (where=(Label ? "Observations Used"));
								 %end;
								 %if &ie=0 %then %do;
									%if %Upcase(&Odds)=YES %then %do;
										%if ^%length(&RandEff &KVars) %then &Otable=OR;
										%else &Ttable=OR;
									%end;
								 %end;
								 %if (&kmodel=1 or %length(&RandEff)) and &covp %then CovParms=cp;
								 %if %upcase(&TraitType)=BINARY %then responseprofile=rp; 

								/*begin: Luciano*/
								%if %upcase(&OutputRSquare)=YES and %index(%upcase(&WhichProc),LOGISTIC) %then
									rsquare= trsq;
								/*end: Luciano*/	
								%if %upcase(&OutputFitStat)=YES %then 
									FitStatistics= fst;
							%end;
						;

						proc &WhichProc data=genotypes %if %length(&selmarkervarsorder_t) %then (where=(_order_ not in (%sysfunc(tranwrd(&selmarkervarsorder_t, %str( ), %str(,)))))); &ProcOption %if &survey=1 %then &ratetotal; 
							%if %Upcase(&Odds)=YES and ^%length(&RandEff &KVars) %then alpha=&Alpha;;
							*begin: S1139177 Luciano efficiency improvement*;
							*class %if &NeedConstant=1 %then constant; &ClassVars &ClassOpt;
							class %if &NeedConstant=1 %then constant; &ClassVars &ExtraClassVars &ClassOpt;
							*end: S1139177 Luciano efficiency improvement*;
							
							model &TraitVar &TraitOpt = %if &NeedConstant=1 %then constant; &FixedEff &selFixedEff_t &selMarkerVars_t &Genotype &Interaction &ModOption;

							%if &kmodel=1 %then %do;
								*begin: S1139177 Luciano efficiency improvement*;
								%if %upcase(&SpeedK)=YES %then %do;
									repeated _IndivID_ / type=lin(1) ldata=Kmats subject=_one_ local;
								%end;
								%else %do;
									random &KVars / type=toep(1) %if %length(&PedID) %then subject=&PedID;;
								%end;
								*end: S1139177 Luciano efficiency improvement*;
							%end;

							%if %length(&RandEff) %then %do;
								random &RandEff %if %upcase(&TraitType)=NOMINAL %then group=&TraitVar;;
							%end;

							%if %length(&ParmsStmt_t) %then %do;
								parms &ParmsStmt_t ;
							%end;					

							%if %length(&StrataVars)>0 %then %do;
								strata &StrataVars;
							%end;
							%if &survey=1 %then %do;
								%if %length(&ClusterVars) %then %do;
									cluster &ClusterVars;
								%end;
								%if %length(&WeightVar) %then %do;
									weight &WeightVar;
								%end;
							%end;
							%if %Upcase(&Odds)=YES and &ie=0 %then %do;
								%if ^%length(&RandEff &KVars) %then %do;
									oddsratio Genotype;
								%end;
								%else %do;
									&TStmt &teststmt / alpha=&Alpha exp cl;;
								%end;
							%end;
							%if (%upcase(&OutputResid)=YES or %upcase(&OutputPred)=YES) and %length(&RandEff) %then %do;
								id _IndivID_;
							%end;					

							by _order_ %if &OutputMajAllele %then MajorAllele; &ByVars;

							%if %upcase(&OutputSurvFunc)=YES or ((%upcase(&OutputResid)=YES or %upcase(&OutputPred)=YES) and %upcase(&TraitType)=SURVIVAL) %then %do;
								output out=outres
								%if %upcase(&OutputSurvFunc)=YES %then survival=SurvivalFunctionEst;
								%if %upcase(&OutputResid)=YES and %upcase(&TraitType)=SURVIVAL %then resdev=Resid;
								%if %upcase(&OutputPred)=YES and %upcase(&TraitType)=SURVIVAL %then predicted=pred;
							   ;
							%end;	
							*begin: S1139177 Luciano efficiency improvement*;
							%if &kmodel=1 and %upcase(&SpeedK)=YES %then 
								ods exclude classlevels;;
							*end: S1139177 Luciano efficiency improvement*;
						quit;
						
						options notes;

						/* kemicl - added to catch error when all effects are not estimable */			
						 %NObsVars(ta);
						 %if ^&nobs %then %do;
							%put ERROR:  PROC &WhichProc generated no estimates for the Trend Test for trait &TraitVar..  There may be excessive missing data or the contrast may be nonestimable. Please see the log for more details.;
							%goto skip2;
						 %end;

						 %put Test = Trend, Trait = &TraitVar, Effect = Genotype &Interaction, Permutation = &p;   			                   

						%if &p=0 %then %do;
							%if %upcase(&TraitType)=BINARY %then %do;

								proc transpose data=rp out=rp(drop=_name_) prefix=NumTrait;
									by _order_ &ByVars;
									var count;
									id %if %index(%upcase(&WhichProc),LOGISTIC) %then Outcome; %else &TraitVar;;
								run;

								%let datatomerge=rp;
							%end;
							%else %let datatomerge=;

							%if &WhichProc ne SURVEYREG %then %do;

								data ta;
									merge tnobs(keep=_order_ &ByVars nobsused) &datatomerge ta;
									by _order_ &ByVars;
									rename nobsused=SampleSize;
								run;
							%end;

							/*begin: including RSquare for logistic regression. Luciano*/
							%if %upcase(&OutputRSquare)=YES and %index(%upcase(&WhichProc),LOGISTIC) %then %do;
								data ta;
									merge ta trsq(keep= _order_ nValue1 nValue2 %if &OutputMajAllele %then MajorAllele; &ByVars);
									by _order_ %if &OutputMajAllele %then MajorAllele; &ByVars;
									rename nValue1= RSquare_Trend nValue2=Rescaled_RSquare_Trend;
								run;
							%end;
							/*end: Luciano*/
							
							%if %upcase(&OutputFitStat)=YES %then %do;
								%put WhichProc= &WhichProc;
								/*data OutLib.fst; set fst; run;*/
								/*data OutLib.ta; set ta; run;*/
								
								proc transpose data=fst(
									%if %index(%upcase(&WhichProc),LOGISTIC) %then %do;
										rename=(
											criterion= descr 
											interceptandcovariates= value
										)
									%end;
									%else %if %index(%upcase(&WhichProc),PHREG) %then %do;
										rename=(
											criterion= descr  
											withcovariates= value
										)
									%end;
									)
									out=fst(drop= _name_); 
									var value;
									id descr;
									by _order_ %if &OutputMajAllele %then MajorAllele; &ByVars;
								run;
								
								/*data OutLib.tst2; set fst; run;*/
								
								data ta;
									merge ta fst;
									by _order_ %if &OutputMajAllele %then MajorAllele; &ByVars;
									rename
									%if %index(%upcase(&WhichProc),MIXED) %then %do;
										_2_Res_Log_Likelihood= _2_Res_Log_Likelihood_Trend
										AIC__Smaller_is_Better_= AIC_Smaller_is_Better_Trend
										AICC__Smaller_is_Better_= AICC_Smaller_is_Better_Trend
										BIC__Smaller_is_Better_= BIC_Smaller_is_Better_Trend
									%end;
									%else %if %index(%upcase(&WhichProc),GLIMMIX) %then %do;
										%if (%upcase(&TraitType)=COUNT and %length(&RandEff)>0) 
											or (%upcase(&TraitType)=BINARY and %length(&RandEff)>0) %then %do;
											%if %upcase(&GMethod)=RSPL or %upcase(&GMethod)=RMPL %then %do;
												_2_Res_Log_Pseudo_Likelihood= _2_Res_Log_Pseud_Likel_Trend
												Generalized_Chi_Square= Generalized_ChiSquare_Trend
												Gener__Chi_Square___DF= Gener_ChiSq_DF_Ratio_Trend
											%end;
											%else %if %upcase(&GMethod)=MSPL or %upcase(&GMethod)=MMPL %then %do;
												_2_Log_Pseudo_Likelihood= _2_Log_Pseud_Likel_Trend
												Generalized_Chi_Square= Generalized_ChiSquare_Trend
												Gener__Chi_Square___DF= Gener_ChiSq_DF_Ratio_Trend
											%end;
											%else %if %upcase(&GMethod)=QUAD or %upcase(&GMethod)=LAPLACE %then %do;
												_2_Log_Likelihood= _2_Log_Likelihood_Trend
												AIC___smaller_is_better_= AIC_Smaller_is_Better_Trend
												AICC__smaller_is_better_= AICC_Smaller_is_Better_Trend
												BIC___smaller_is_better_= BIC_Smaller_is_Better_Trend
												CAIC__smaller_is_better_= CAIC_smaller_is_better_Trend
												HQIC__smaller_is_better_= HQIC_smaller_is_better_Trend											
											%end;
										%end;
										%else %if %upcase(&TraitType)=COUNT and %length(&RandEff)=0 %then %do; 		
											_2_Log_Likelihood= _2_Log_Likelihood_Trend
											AIC___smaller_is_better_= AIC_Smaller_is_Better_Trend
											AICC__smaller_is_better_= AICC_Smaller_is_Better_Trend
											BIC___smaller_is_better_= BIC_Smaller_is_Better_Trend
											CAIC__smaller_is_better_= CAIC_smaller_is_better_Trend
											HQIC__smaller_is_better_= HQIC_smaller_is_better_Trend
											Pearson_Chi_Square= Pearson_ChiSquare_Trend
											Pearson_Chi_Square___DF= Pearson_ChiSq_DF_Ratio_Trend											
										%end;
										%else %if %upcase(&TraitType)=NOMINAL or %upcase(&TraitType)=ORDINAL %then %do;
											%if %upcase(&GMethod)=RSPL or %upcase(&GMethod)=RMPL %then %do;
												_2_Res_Log_Pseudo_Likelihood= _2_Res_Log_Pseud_Likel_Trend
											%end;
											%else %if %upcase(&GMethod)=MSPL or %upcase(&GMethod)=MMPL %then %do;
												_2_Log_Pseudo_Likelihood= _2_Log_Pseud_Likel_Trend
											%end;
											%else %if %upcase(&GMethod)=QUAD or %upcase(&GMethod)=LAPLACE %then %do;
												_2_Log_Likelihood= _2_Log_Likelihood_Trend
												AIC___smaller_is_better_= AIC_Smaller_is_Better_Trend
												AICC__smaller_is_better_= AICC_Smaller_is_Better_Trend
												BIC___smaller_is_better_= BIC_Smaller_is_Better_Trend
												CAIC__smaller_is_better_= CAIC_smaller_is_better_Trend
												HQIC__smaller_is_better_= HQIC_smaller_is_better_Trend
											%end;	
										%end;
										%else %if (%upcase(&TraitType)=BINARY and &kmodel=1) %then %do;
											%if %upcase(&GMethod)=RSPL or %upcase(&GMethod)=RMPL %then %do;
												_2_Res_Log_Pseudo_Likelihood= _2_Res_Log_Pseud_Likel_Trend
												Generalized_Chi_Square= Generalized_ChiSquare_Trend
												Gener__Chi_Square___DF= Gener_ChiSq_DF_Ratio_Trend
											%end;
											%else %if %upcase(&GMethod)=MSPL or %upcase(&GMethod)=MMPL %then %do;
												_2_Log_Pseudo_Likelihood= _2_Log_Pseud_Likel_Trend
												Generalized_Chi_Square= Generalized_ChiSquare_Trend
												Gener__Chi_Square___DF= Gener_ChiSq_DF_Ratio_Trend											
											%end;
										%end;										
									%end;
									%else %if %index(%upcase(&WhichProc),PHREG) %then %do;
										_2_LOG_L= _2_LOG_L_Trend
										AIC= AIC_Trend
										SBC= SBC_Trend
									%end;
									%else %if %index(%upcase(&WhichProc),LOGISTIC) %then %do;
										AIC= AIC_Trend
										SC= SC_Trend
										_2_Log_L= _2_Log_L_Trend
									%end;
									;
								run;
							%end;

							%if (&ie=0 or %sysfunc(indexw(%upcase(&ClassVars),%upcase(%scan(&IntEff,&ie))))=0) and %upcase(&TraitType) ne NOMINAL %then %do;

								data ta;
									%if &ie=0 %then %do;
										merge pat(where=(&EffName="&Genotype") keep=&EffName Estimate Stderr) ta(where=(effect ? "&Genotype"));		
									%end;
									%else %do;
										merge pat(where=(&EffName ? "Genotype*" or &EffName ? "*Genotype") keep=&EffName Estimate Stderr) ta(where=(Effect ? "Genotype*" or Effect ? "*Genotype"));										
									%end;
									%if %quote(&EffName)=%str(Variable) %then drop &EffName;;
									rename Estimate = Estimate_Trend StdErr= StdErr_Trend;
								run;

								%let volcanoplot = 1;
							%end;

							 data ta_all;  
								length Trait $32  ;
								set ta_all(in=orig) ta ;
								%if &ie>0 %then %do;
									if orig=1 or index(Effect,"Genotype*")>0 or index(Effect,"*Genotype")>0; 
									/* To make sure interactions in same order for Genotype and Trend tests */
									if index(Effect,"Genotype*")>1 then do;
										Effect=cats("Genotype*",tranwrd(Effect,"Genotype*",""));
									end;
									else if index(Effect,"Genotype")>1 then do;
										Effect=cats("Genotype*",tranwrd(Effect,"*Genotype",""));
									end;					
								%end;
								%else %do;
									where index(Effect,"&Genotype")>0; 
								%end;				
								if not orig then Trait = "&TraitVar";
								label Prob&Stat=' '; 
							 run;

							%if &ie=0 %then %do;
								%if %Upcase(&Odds)=YES  %then %do; 

									data or_all;
										set or_all or;
									run;

									data ta_all;
										length Trait $32;
										set ta_all; set or_all;
										%if ^%length(&RandEff &KVars) %then %do;	
											drop unit;
										%end;
										%else %do;
											drop alpha lower upper;
										%end;							
									run;
								 %end;

								 %if %upcase(&OutputResid)=YES or %upcase(&OutputPred)=YES %then %do;
									%if %sysfunc(exist(outres)) %then %do;
										data outrest_all;
											set outrest_all(in=orig) outres;
											if orig=0 then do;
												_Trait_="&TraitVar";
											end;
										run;		
									%end;
								%end;	
							%end;

							%if &pest=1 %then %do;
								data pat_all;	
									%if %length(&IntEffBuild) %then %do;
										length Interaction $32;
									%end;
									set pat_all(in=orig) pat;
									if orig=0 then do;
										Trait="&TraitVar";
										%if %length(&IntEffBuild) %then %do;
											Interaction="&Interaction";
										%end;
									end;
								run;	
							%end;


							%if (&kmodel=1 or %length(&RandEff)) and &covp %then %do;
								data cpt_all;
									%if %length(&IntEffBuild) %then %do;
										length Interaction $32;
									%end;										
									set cpt_all(in=orig) cp;
									if orig=0 then do;
										Trait="&TraitVar";
										%if %length(&IntEffBuild) %then %do;
											Interaction="&Interaction";
										%end;
									end;
								run;
							%end;		

							%if %upcase(&OutputSurvFunc)=YES  %then %do;
								proc sort data=outres out=geno nodupkey;
									by _order_ &genotype;
								run;

								data geno;
									set geno;
									SurvivalFunctionEst=1;
									&TraitVar = 0;
								run;

								data survcurvest;
									set outres geno;
									if &genotype ne .;								
								run;

								data sft_all;
									%if %length(&IntEffBuild) %then %do;
										length Interaction $32;
									%end;						
									set sft_all(in=orig) survcurvest;
									if orig=0 then do;
										Trait="&TraitVar";
										%if %length(&IntEffBuild) %then %do;
											Interaction="&Interaction";
										%end;
									end;
								run;								

							%end;						
						%end; /* end p=0 */

						%else %do;
							data ta_p; 
								length Trait $32;
								set ta_p(in=orig) ta;
								%if &ie>0 %then %do;
									if orig=1 or index(Effect,"Genotype*")>0 or index(Effect,"*Genotype")>0; 
									/* To make sure interactions in same order for Genotype and Trend tests */
									if index(Effect,"Genotype*")>1 then do;
										Effect=cats("Genotype*",tranwrd(Effect,"Genotype*",""));
									end;
									else if index(Effect,"Genotype")>1 then do;
										Effect=cats("Genotype*",tranwrd(Effect,"*Genotype",""));
									end;
								%end;
								%else %do;
									where index(Effect,"&Genotype")>0; 
								%end;
								if not orig then do;
									Trait = "&TraitVar";
									ProbT&p = Prob&Stat;
								end;
								keep _order_ Trait Effect ProbT&p;
							run;
						%end;					

					%end; /* end if trend */

					%skip2:;

					%if &ie=0 and &survey=1 %then %do;
						%if &raoscottf=1 or &raoscottchi=1 %then %do;

							title2 'Rao-Scott Test';

							ods output ChiSq = rscs(where=(Name1 ? "RS"));                             ;
							proc surveyfreq data=genotypes &ratetotal;
								%if %length(&StrataVars)>0 %then %do;
									strata &StrataVars;
								%end;
								%if %length(&ClusterVars) %then %do;
									cluster &ClusterVars;
								%end;
								%if %length(&WeightVar) %then %do;
									weight &WeightVar;
								%end;			
								tables &TraitVar * Genotype / chisq noprint;
								by _order_ %if &OutputMajAllele %then MajorAllele; &ByVars;
							run;

							%if (&syserr>4) %then %do;
								%let exiterror=1;
								%goto exitm;
							%end;					

							options notes;
							%if %sysfunc(exist(rscs))=0 %then %do;

								data rs;
									set genotypes(keep=_order_ %if &OutputMajAllele %then MajorAllele; &ByVars);
									by _order_ %if &OutputMajAllele %then MajorAllele; &ByVars;
									%if %length(&ByVars) %then %do;
										if first.&lastby;
									%end;
									%else %do;
										if first._order_;
									%end;
									retain Effect "Genotype";
									%if &raoscottchi=1 %then %do;
										retain ChiSq_RaoScott DF_RaoScott Prob_RaoScott_ChiSq .;
									%end;
									%if &raoscottf=1 %then %do;
										retain FValue_RaoScott NDF_RaoScott	DDF_RaoScott Prob_RaoScott_F .;
									%end;
								run;
							%end;
							%else %do;
								proc transpose data=rscs out=rs;
									var nValue1;
									by _order_ %if &OutputMajAllele %then MajorAllele; &ByVars;
									id Name1;
								run;		

								proc datasets nolist;
									delete rscs;
								quit;

								data rs;
									set rs;
									drop _name_ %if &raoscottf=0 %then _rsf_ ndf_rsf ddf_rsf p_rsf; 
													%if &raoscottchi=0 %then _rschi_ df_rschi P_rschi;;
									rename %if &raoscottchi=1 %then _rschi_=ChiSq_RaoScott df_rschi=DF_RaoScott P_rschi=Prob_RaoScott_ChiSq;
											 %if &raoscottf=1 %then _rsf_=FValue_RaoScott ndf_rsf=NDF_RaoScott ddf_rsf=DDF_RaoScott p_rsf=Prob_RaoScott_F;;
									Effect="Genotype";
								run;
							%end;

							data rs_all; 
								length Trait $32;
								set rs_all(in=orig) rs;
								if not orig then Trait = "&TraitVar";
								label %if &raoscottchi=1 %then Prob_RaoScott_ChiSq=' '; %if &raoscottf=1 %then Prob_RaoScott_F=' ';;
							 run;

						%end;
					%end;				

					options notes;

					title2;

					%let ie=%eval(&ie+1);   
					%let Interaction=%scan(&IntEffBuild,&ie,' ');

				%end; /* end loop over interactions */
				
				%endtrait:;
			%end;  /* end loop over traits */

			%*endloop:;

			%let first = %eval(&last + 1);
			%let last = %eval(&first + &BlockSize - 1);
			%if &last > &nummark %then %let last = &nummark;
			%let Block = %eval(&Block + 1);		
		%end; /* end block loop */
		
		%*let exiterror=1;
		%*goto exitm;
		
		%if &GetCovParms %then %goto exitm;	

		%if &p %then %do;

			proc datasets nolist;
				delete traits_p&p traits_po&p;
			quit;

			%if (&geno=1) %then %do;
				data ma_a_p;
					%if &p>1 %then %do;
						merge ma_a_p ma_p;
						by Trait effect _order_ ;
					%end;
					%else %do;
						set ma_p;
					%end;
				run;
			%end;

			%if &trend=1 %then %do;

				data ta_a_p;
					%if &p>1 %then %do;
						merge ta_a_p ta_p;
						by Trait effect _order_ ;
					%end;
					%else %do;
						set ta_p;
					%end;
				run;		
			%end;

			%if &p=&PerfPerm %then %do;

				%if &geno=1 %then %do;

					data ma_a(drop=probg1-probg&PerfPerm permprobg npermg p) allprobs(keep=trait effect _order_ probg: prob&Stat);
						merge ma_a ma_a_p;
						by Trait Effect _order_ ;
						array pps{*} ProbG1-ProbG&PerfPerm;
						PermProbG = 0;
						NPermG = 0;
						if Prob&Stat=. then ProbGenotypePerm = .;
						else do;
							do p=1 to dim(pps);
								if Prob&Stat ge pps{p} then PermProbG+1;
								if pps{p} ne . then NPermG+1;
							end;
							ProbGenotypePerm = (PermProbG +1)/ (NPermG + 1);
						end;
					run;

					%if %upcase(&AdjPerm)=YES %then %do;

						proc iml;
							use allprobs var _all_;
							read all var _char_ into Effect;
							read all var _num_ into pvalues;
							print pvalues;
							ur=uniqueby(effect,{1,2},1:nrow(effect));
							print ur;
							start=1;
							byg=1;
							obsp = 2;

							do i=1 to nrow(ur);
								if i=nrow(ur) then size=nrow(effect) - ur[nrow(ur)];
								else size=ur[i+1]-ur[i]-1;
								sub=pvalues[start:start+size,];

								num = J(nrow(sub),1,0);
								denom = J(nrow(sub),1,0);
								MCP = J(nrow(sub),1,0);
								do col=1 to &PerfPerm;
									minp = min(sub[,col+2]);
									num[,1] = num[,1] + (minp <= sub[,obsp]);
								end;
								do row=1 to nrow(sub);
									if sub[row,2]=. then MCP[row,1] = .;
									else MCP[row,1] = (num[row,1] + 1) / (&PerfPerm + 1); 
								end;
								bygM = J(nrow(sub),1,byg);
								MCP = sub[,1] || MCP;
								if byg=1 then MCP_all = MCP;
								else MCP_all = MCP_all // MCP;

								start=start+size+1;
								byg=byg+1;
							end;
							varnames={_order_,"ProbGenotypePermAdj"};
							create mtcpval from MCP_all[colname=varnames];
							append from MCP_all;
							varnames2={trait,effect};
							create trteff from effect[colname=varnames2];
							append from effect;
						quit;

						data mtcpval;
							merge trteff mtcpval;
						run;		

						data ma_a;
							merge ma_a mtcpval;
							by Trait Effect _order_;
						run;
					%end;

				%end;

				%if &trend=1 %then %do;

					data ta_all(drop=probt1-probt&PerfPerm permprobt npermt p) allprobs(keep=trait effect _order_ probt1-probt&PerfPerm prob&Stat);
						merge ta_all ta_a_p;
						by Trait Effect _order_ ;
						array pps{*} ProbT1-ProbT&PerfPerm;
						PermProbT = 0;
						NPermT = 0;
						if Prob&Stat=. then ProbTrendPerm = .;
						else do;
							do p=1 to dim(pps);
								if Prob&Stat ge pps{p} then PermProbT+1;
								if pps{p} ne . then NPermT+1;
							end;
							ProbTrendPerm = (PermProbT +1)/ (NPermT + 1);
						end;
					run;			

					%if %upcase(&AdjPerm)=YES %then %do;

						proc iml;
							use allprobs var _all_;
							read all var _char_ into Effect;
							read all var _num_ into pvalues;
							print pvalues;
							ur=uniqueby(effect,{1,2},1:nrow(effect));
							print ur;
							start=1;
							byg=1;
							obsp = 2;

							do i=1 to nrow(ur);
								if i=nrow(ur) then size=nrow(effect) - ur[nrow(ur)];
								else size=ur[i+1]-ur[i]-1;
								sub=pvalues[start:start+size,];

								num = J(nrow(sub),1,0);
								denom = J(nrow(sub),1,0);
								MCP = J(nrow(sub),1,0);

								do col=1 to &PerfPerm;
									minp = min(sub[,col+2]);
									num[,1] = num[,1] + (minp <= sub[,obsp]);
								end;
								do row=1 to nrow(sub);
									if sub[row,2]=. then MCP[row,1] = .;
									else MCP[row,1] = (num[row,1] + 1) / (&PerfPerm + 1); 
								end;							
								bygM = J(nrow(sub),1,byg);
								MCP = sub[,1] || MCP;
								if byg=1 then MCP_all = MCP;
								else MCP_all = MCP_all // MCP;

								start=start+size+1;
								byg=byg+1;
							end;
							varnames={_order_,"ProbTrendPermAdj"};
							create mtcpval from MCP_all[colname=varnames];
							append from MCP_all;
							varnames2={trait,effect};
							create trteff from effect[colname=varnames2];
							append from effect;
						quit;

						data mtcpval;
							merge trteff mtcpval;
						run;		

						data ta_all;
							merge ta_all mtcpval;
							by Trait Effect _order_;
						run;
					%end;

				%end;


			%end;
		%end;
	%end; /* end perms */
	
	/* Set back to 1 to do post-calc processing*/
	%if &imputed=1 %then %do;
		%let geno=&old_geno;
		%if &geno=1 %then %do;
			/* Rename to ma_a now */
			proc datasets nolist;
				delete ma_a pag_all cpg_all;
				change ma_all=ma_a pag_a=pag_all cpg_a=cpg_all;
			quit;
		%end;
	%end;

	%if &geno=1 %then %do;
		%Nobsvars(ma_a);
		%if &nobs=0 %then %do;
			%put ERROR: Genotype tests did not run successfully.  See the SAS log for more details.;
			%let exiterror = 1;
			%goto exitm;
		%end;
	%end;
	%if &trend=1 %then %do;
		%Nobsvars(ta_all);
		%if &nobs=0 %then %do;
			%put ERROR: Trend tests did not run successfully.  See the SAS log for more details.;
			%let exiterror=1;
			%goto exitm;
		%end;
	%end;

	%if %Upcase(&Odds)=YES %then %do;      
		 data ta_all;
			set ta_all;
			%if ^%length(&RandEff &KVars) %then %do;	
				Log_OddsRatio_Trend=log(OddsRatioEst);
			%end;
			%else %do;
				Log_OddsRatio_Trend=log(ExpEstimate);
				rename ExpEstimate=OddsRatioEst ExpUpper=ORUpperCL ExpLower=ORLowerCL;
				drop Statement label estimate stderr df tvalue probt;
			%end;	 	
		 run;
	%end;					


	%if &imputed=1 %then %do;
		%let ByVars=&OldByVars;
		%let JBy=%sysfunc(translate(&ByVars,","," "));
	%end;

	%let FillByVars= &ByVars;          /* kemicl - Create new macro to keep original By variables to build output table */

	%global JByOdds;		   /* kemicl - Create new macro JByOdds for Odds Ratio plots to not include interaction eff */
	%let JByOdds= &ByVars;

	%if &NTrait>1 %then %do;
		/* This stuff for Venns */
		%if %length(&IntEff)>0 %then %do;
			%let NonTraitByVars=&NonTraitByVars Effect;
			%let JNonTraitByVars = &JNonTraitByVars :Effect;
			%let OrigNbyval = %eval(&OrigNbyval*&NumInt);
		%end;

		/***********************/

		%if %length(&ByVars)>0 %then %do;
		 %let ByVars = Trait &ByVars;
		 %let ByVarsOnly = Trait &ByVarsOnly;
		 %let JBy = %str(Trait,&JBy);
		 %let JByOdds= &JBy;
		%end;
		%else %do;
		 %let ByVars = Trait;
		 %let ByVarsOnly = Trait;
		 %let JBy=Trait;
		 %let JByOdds= &JBy;
		%end;
		%let Nbyval = %eval(&Nbyval*&Ntrait);
	%end;

	%if &snpsnp %then %do;
		%goto exitm;
	%end;

	/* Set back to actual number of markers */
	%if &imputed=1 %then %let nummark=&nummark_orig;

	/* kemicl - New code to make effects,trait and by variables table for estimates to be filled in */
	/* wehass - switched order of trend and geno for imputed snp since no interactions included for geno test */

	/* in case there are missing by groups for one of the tests, figure out which has more obs and do that one */
	%let trendfirst = 1;
	%if &trend=1 and &geno=1 and %length(&IntEff)=0 %then %do;
		%Nobsvars(ta_all);
		%let tnobs=&nobs;
		%Nobsvars(ma_a);
		%let mnobs = &nobs;

		%if &mnobs > &tnobs %then %let trendfirst=0;
	%end;

	%if &trend=1 and &trendfirst %then %do;
		proc sort data=Ta_all out=effect_map(keep=Effect Trait &FillByVars) nodupkey;
			by Effect &ByVars;
		run;
	%end;
	%else %if (&geno=1) %then %do;
		proc sort data=Ma_a out=effect_map(keep=Effect Trait &FillByVars) nodupkey;
			by Effect &ByVars;
		run;
	%end;
	%else %do;
		proc sort data=rs_all out=effect_map(keep=Effect Trait &FillByVars) nodupkey;
			by Effect &ByVars;
		run;
	%end;

	data effect_map;
		set effect_map;
		do e=1 to &nummark;
			output;
		end;
		rename e=_order_;
	run;

	proc sort data=effect_map;
		by _order_;
	run;

	data mapdata2;  /* kemicl - Use mapdata2 instead of mapdata to merge in all tables to make final output table */
		merge mapdata effect_map;
		by _order_;
	run;

	%if &NTrait>1 or %length(&IntEff)>0 or %length(&FillByVars)>0 %then %do;
		proc sort data=mapdata2;
			by _order_ &ByVars Effect ;
		run;
	%end;

	%if (&geno=1) %then %do;

		%if &NTrait>1 or %length(&IntEff)>0 or %length(&FillByVars)>0 or &imputed=1 %then %do;
			proc sort data=ma_a;
				by _order_ &ByVars Effect ;
			run;
		%end;

		%if &lsm=1 %then %do;

			proc sort data=outlsm_all;
				by _order_ &ByVars diff genotype;
			run;

			data &SNPTraitAssoc_LSM;
				merge mapdata outlsm_all;
				by _order_;
				%if %length(&selmarkervarsorder_g) %then %do;  
					where _order_ not in (%sysfunc(tranwrd(&selmarkervarsorder_g, %str( ), %str(,))));
				%end;
				drop %if ^&QKSelProf %then _order_; diff _genotype %if &OutputMajAllele %then MajorAllele;;
				rename Estimate = LSMeans_Estimate;
			run;

			%if %upcase(&ProcessName) ^= QKMIXEDMODEL %then %do;
				%PackageInsertDataset(Genotype LS means and diffs from &ProcessName, OutLib, &SNPTraitAssoc_LSMName, _type=other);
			%end;
	
			data outlsm_all;
				set outlsm_all;
				if diff;
			run;
			%let transds = outlsm_all;

			%if ^&QKSelProf %then %do;		
				%if %length(&MTC) %then %do;
					%if %length(&ByVars) %then %do;
						proc sort data=outlsm_all;
							by &ByVars _order_;
						run;
					%end;

					%AdjPValueName(method=%scan(&mtc,1));
					proc multtest pdata(probt)=outlsm_all %scan(&mtc,1) out=adjdiffs;
						%if %length(&ByVars) %then %do;
							by &ByVars;
						%end;
					run;
					%let transds = adjdiffs;
				%end;

				%else %do;
					%let mtpvar = Probt;
					%if %length(&ByVars) %then %do;
						proc sort data=outlsm_all;
							by &ByVars _order_;
						run;
					%end;
				%end;

				proc transpose data=&transds out=trans1(drop=_name_) prefix=LSDiff_ suffix=_0;
					var estimate;
					by  &ByVars _order_;
					id Genotype;
				run;

				proc transpose data=&transds out=trans2(keep=ProbLS:) prefix=ProbLSDiff_ suffix=_0;
					var &mtpvar;
					by  &ByVars _order_;
					id Genotype;
				run;

				data lsmtrans;
					set trans1; set trans2;
					Effect = "Genotype";
					%if %length(&Conv) %then %do;
						array problsa{*} problsdiff_:;
						do _p=1 to dim(problsa);
							%if %upcase(&Conv)=NEGLOG %then %do;
								problsa{_p} = -log(problsa{_p});
							%end;
							%else %do;
								problsa{_p} = -log10(problsa{_p});
							%end;			
						end;
						drop _p;
					%end;					
				run;

				proc sort data=lsmtrans out=outlsm_all;
					by _order_ &ByVars Effect ;
				run;
			%end;
		%end;	
		
		data ma_a;
			merge mapdata2 ma_a %if &imputed=1 %then (drop=&SNPIDVar); %if &lsm and ^&QKSelProf %then outlsm_all;;
			by _order_ &ByVars Effect;
			%if %Upcase(&Stat) ne CHISQ %then %do;
				rename NumDF=NumDF_Genotype DenDF=DenDF_Genotype FValue=FValue_Genotype Prob&Stat=ProbGenotype ; 
				%if &survey=0 %then %do;
					if DenDF=0 then Rsquare_Genotype = .;
					else Rsquare_Genotype = (NumDF*FValue/DenDF)/(1+NumDF*FValue/DenDF);
				%end;
			%end;
			%else %do;
				rename DF=DF_Genotype WaldChiSq=WaldChiSq_Genotype Prob&Stat=ProbGenotype;
			%end;
		run;
		
		/*data OutLib.ma_a; set ma_a; run;*/

		proc sort data=ma_a;
			by &AnnoGroup &AnnoLoc &ByVars Effect ;
		run;
	%end;

	%if (&trend=1) %then %do;
		%if &NTrait>1 or %length(&IntEff)>0 or %length(&FillByVars)>0 %then %do;
			proc sort data=ta_all;
				by _order_ &ByVars Effect;
			run;

		%end;

		%if &imputed=1 %then %do;
			%if %upcase(&Stat)=T %then %let Stat=F;
		%end;

		data ta_all;
			merge mapdata2 ta_all %if &imputed=1 %then (drop=&SNPIDVar);;
			by _order_ &ByVars Effect;
		%*	%if &TraitType=SContinuous %then drop effect;;	
			%if %Upcase(&Stat) ne CHISQ %then %do;
				rename NumDF=NumDF_Trend DenDF=DenDF_Trend FValue=FValue_Trend Prob&Stat=ProbTrend;
				%if &survey=0 %then %do;
					if DenDF=0 then Rsquare_Trend = .;
					else Rsquare_Trend = (NumDF*FValue/DenDF)/(1+NumDF*FValue/DenDF);
				%end;
			%end;
			%else %do;
				rename DF=DF_Trend WaldChiSq=WaldChiSq_Trend Prob&Stat=ProbTrend;
			%end;
			%if %Upcase(&Odds)=YES %then %do;
					rename OddsRatioEst=OddsRatio_Trend;
			%end;		
		run; 

		proc sort data=ta_all;
			by &AnnoGroup &AnnoLoc &ByVars Effect;
		run;
	%end;

	%if &survey=1 %then %do;
		%if (&raoscottf=1 or &raoscottchi=1) %then %do;
			%if &NTrait>1 %then %do;
				proc sort data=rs_all;
					by _order_ &ByVars Effect;
				run;
			%end;

			data rs_all;
				merge mapdata2 rs_all;
				by _order_ &ByVars Effect;
			run; 

			proc sort data=rs_all;
				by &AnnoGroup &AnnoLoc &ByVars Effect;
			run;
		%end;
	%end;	

	%if &geno=1 %then %do;
		%if &NTrait>1 or %length(&IntEff)>0 or &imputed=1 %then %do;
			%if &pest = 1 %then %do;
				proc sort data=pag_all;
					by _order_;
				run;
			%end;

			%if (&kmodel=1 or %length(&RandEff)) and &covp %then %do;
				proc sort data=cpg_all;
					by _order_;
				run;
			%end;
		%end;

		%if %upcase(&OutputResid)=YES or %upcase(&OutputPred)=YES %then %do;
		
			/*data outlib.outresg_all; set outresg_all; run;*/

			%Nobsvars(outresg_all);
			%let rds = %sysfunc(open(outresg_all));
			%if %upcase(&OutputResid)=YES %then %let residnum = %sysfunc(varnum(&rds,RESID));
			%if %upcase(&OutputPred)=YES %then %let prednum = %sysfunc(varnum(&rds,PRED));
			%let rc=%sysfunc(close(&rds));
			
			%if %upcase(&OutputResid)=YES and %upcase(&OutputPred)=YES %then %do;
				%if &residnum=0 %then %do;
					%let _outpnum= &residnum;
					%let ErrString= The residuals for the Genotype Association Test could not be computed.;
				%end;
				%else %if &prednum=0 %then %do;
					%let _outpnum= &prednum;
					%let ErrString= The predicted values for the Genotype Association Test could not be computed.;
				%end;
				%else %do;
					%let _outpnum= &residnum;
				%end;
			%end;
			%else %if %upcase(&OutputResid)=YES and %upcase(&OutputPred)^=YES  %then %do;
				%let _outpnum= &residnum;
				%if &residnum=0 %then
					%let ErrString= The residuals for the Genotype Association Test could not be computed.;
			%end;
			%else %if %upcase(&OutputResid)^=YES and %upcase(&OutputPred)=YES  %then %do;
				%let _outpnum= &prednum;
				%if &prednum=0 %then
					%let ErrString= The predicted values for the Genotype Association Test could not be computed.;
			%end;
			
			%if &nobs=0 %then %do;
				%if %upcase(&OutputResid)=YES and %upcase(&OutputPred)=YES %then
					%let ErrString= Either the residuals or predicted values for the Genotype Association Test could not be computed.;
				%else %if %upcase(&OutputResid)=YES and %upcase(&OutputPred)^=YES %then
					%let ErrString= The residuals for the Genotype Association Test could not be computed.;
				%else %if %upcase(&OutputResid)^=YES and %upcase(&OutputPred)=YES %then
					%let ErrString= The predicted values for the Genotype Association Test could not be computed.;
			%end;
			
			%if &nobs=0 or &_outpnum=0 %then %do;
				%*put ERROR: The genotype residuals could not be computed.;
				%put WARNING: &ErrString;
				%let OutputResid=NO;
				%let OutputPred=NO;
				
				%if %length(&ProcessName) > 22 %then %do;
					%let ProcessNameShort= %substr(&ProcessName, 1, 22);
				%end;
				%else %do;
					%let ProcessNameShort= &ProcessName;
				%end;
				
				%let SNPTraitAssocMacro_ScErr= &ProcessNameShort._ScErr;
				%*put ScriptErr= &SNPTraitAssocMacro_ScErr;
		    		%global &SNPTraitAssocMacro_ScErr;
				%PrepOutFile(&SNPTraitAssocMacro_ScErr,&SNPTraitAssocMacro_ScErr.Name,saserror.jsl);
				%*put ScriptErr= &&&SNPTraitAssocMacro_ScErr;
				%*put ScriptErrName= &&&SNPTraitAssocMacro_ScErr.Name;

				data _null_;
					file "&&&SNPTraitAssocMacro_ScErr" lrecl=32767 ;
					put '//!' ;
					put "Names Default to Here(1);" ;
					put "new Window(""WARNING running &FullAPName.""," ;
					put "vlb=VListBox(" ; 
					put "textBox(""The following SAS warning ocurred in process &FullAPName:""),";
					put "errtxt = TextEditBox(""\!N""||""";
					put "&ErrString";
					put """||""\!N"",WhiteBoxStyle(0)),";
					put "errtxt << Font Color(3)," ; 
					put "errtxt << Set Wrap(1000)," ;
					/*put "TextBox(""Please refer to the SAS log displayed in the JMP log window for further details.\!N\!N""),";*/
					put ")" ;
					put ");";
				run;
	  			%PackageInsertFile(jsl code from &ProcessName, &OutPath, &&&SNPTraitAssocMacro_ScErr.Name, no, no, yes);
			%end;
			%else %do;

				%if &NTrait>1 %then %do;
					proc sort data=outresg_all;
						by _order_;
					run;
				%end;

				data outresg_all;
					merge mapdata outresg_all;
					by _order_;
					%if %length(&selmarkervarsorder_g) %then %do;  
						where _order_ not in (%sysfunc(tranwrd(&selmarkervarsorder_g, %str( ), %str(,))));
					%end;
				run;

				proc sort data=outresg_all;
					by _individ_ _order_ _Trait_ ;
				run;
				
				%if %upcase(&OutputResid)=YES %then %do;				
					proc transpose data=outresg_all out=outresgt(drop=_name_) let
						%if &NTrait>1 %then %do;
							prefix=Res_ delimiter=_Trt_
						%end;
						%else %do;
							prefix=Resid_
						%end;
						;
						var resid;
						id %if &NTrait>1 %then _order_  _Trait_; %else &AnnoLabel;;
						by _IndivID_;
					run;

					data &SNPTraitAssoc_ORG;
						 merge othervars outresgt;
						 by _IndivID_;
						%if ^&QKSelProf %then %do;
							drop _IndivID_;
						%end;
					run;

					%if %upcase(&ProcessName) ^= QKMIXEDMODEL %then %do;
						%PackageInsertDataset(Genotype residual data from &ProcessName, OutLib, &SNPTraitAssoc_ORGName);
					%end;
				%end;
				
				%if %upcase(&OutputPred)=YES %then %do;				
					proc transpose data=outresg_all out=outpredgt(drop=_name_) let
						%if &NTrait>1 %then %do;
							prefix=Pred_ delimiter=_Trt_
						%end;
						%else %do;
							prefix=Pred_
						%end;
						;
						var pred;
						id %if &NTrait>1 %then _order_  _Trait_; %else &AnnoLabel;;
						by _IndivID_;
					run;

					data &SNPTraitAssoc_OPG;
						 merge othervars outpredgt;
						 by _IndivID_;
						%if ^&QKSelProf %then %do;
							drop _IndivID_;
						%end;
					run;

					%if %upcase(&ProcessName) ^= QKMIXEDMODEL %then %do;
						%PackageInsertDataset(Genotype predicted data from &ProcessName, OutLib, &SNPTraitAssoc_OPGName);
					%end;
				%end;
			%end;

		%end;

		%if &pest = 1 %then %do;
			data &SNPTraitAssoc_PEG;
				merge mapdata pag_all %if &imputed=1 %then (drop=&SNPIDVar);;
				by _order_;
				%if %length(&selmarkervarsorder_g) %then %do;  
					where _order_ not in (%sysfunc(tranwrd(&selmarkervarsorder_g, %str( ), %str(,))));
				%end;
				drop %if ^&QKSelProf %then _order_; _ESTTYPE_ %if &OutputMajAllele %then MajorAllele;;
			run;

			%if %upcase(&ProcessName) ^= QKMIXEDMODEL %then %do;
				%PackageInsertDataset(Genotype parameter estimate data from &ProcessName, OutLib, &SNPTraitAssoc_PEGName, _type=other);
			%end;
		%end;

		%if (&kmodel=1 or %length(&RandEff)) and &covp %then %do;
			/*S1368466: When the annotation group variable name is "group" and the random statement
				option is "group=sex", the "group" variable in the output data set is truncated
				because there are multiple columns with same name and different lengths*/

			%let did=%sysfunc(open(cpg_all));
			%let AnnGrpVar=%sysfunc(varnum(&did,&AnnoGroup));
			%let rc=%sysfunc(close(&did));
			
			%if &AnnGrpVar %then %do;
				%if %sysevalf(%length(&AnnoGroup) >= 30) %then %do;
					%let AnnGrpNew= _%trim(%left(%substr(&AnnoGroup, 1, 30)))_;
				%end;
				%else %do;
					%let AnnGrpNew= _%trim(%left(&AnnoGroup))_;
				%end;
				%put AnnGrpNew= &AnnGrpNew;
			%end;				
		
			data &SNPTraitAssoc_CPG;
				merge mapdata cpg_all %if &AnnGrpVar %then %do; (rename=(&AnnoGroup= &AnnGrpNew)) %end;;
				by _order_;
				%if %length(&selmarkervarsorder_g) %then %do;  
					where _order_ not in (%sysfunc(tranwrd(&selmarkervarsorder_g, %str( ), %str(,))));
				%end;
				%if ^&QKSelProf or &OutputMajAllele %then %do;
					drop %if ^&QKSelProf %then _order_; %if &OutputMajAllele %then MajorAllele;;
				%end;
			run;

			%if %upcase(&ProcessName) ^= QKMIXEDMODEL %then %do;
				%PackageInsertDataset(Genotype covariance parameter data from &ProcessName, OutLib, &SNPTraitAssoc_CPGName, _type=other);
			%end;

		%end;	

		%if %upcase(&OutputSurvFunc)=YES %then %do;

			proc sort data=sfg_all;
				by _order_;
			run;

			data &SNPTraitAssoc_sfg;
				merge mapdata sfg_all;
				by _order_;
				%if ^&QKSelProf or &OutputMajAllele or &NeedConstant %then %do;
					drop %if ^&QKSelProf %then _order_; %if &OutputMajAllele %then MajorAllele; %if &NeedConstant %then constant;;
				%end;
			run;

			%if %upcase(&ProcessName) ^= QKMIXEDMODEL %then %do;
				%PackageInsertDataset(Genotype survival function data from &ProcessName, OutLib, &SNPTraitAssoc_sfgName);
			%end;	

		%end;	

	%end;

	%if &trend=1 %then %do;
		%if &NTrait>1 or %length(&IntEff)>0 %then %do;
			%if &pest=1 %then %do;
				proc sort data=pat_all;
					by _order_;
				run;
			%end;

			%if (&kmodel=1 or %length(&RandEff)) and &covp %then %do;
				proc sort data=cpt_all;
					by _order_;
				run;
			%end;		
		%end;

		%if %upcase(&OutputResid)=YES or %upcase(&OutputPred)=YES %then %do;

			%Nobsvars(outrest_all);
			%let rds = %sysfunc(open(outrest_all));
			%if %upcase(&OutputResid)=YES %then %let residnum = %sysfunc(varnum(&rds,RESID));
			%if %upcase(&OutputPred)=YES %then %let prednum = %sysfunc(varnum(&rds,PRED));
			%let rc=%sysfunc(close(&rds));
			
			%if %upcase(&OutputResid)=YES and %upcase(&OutputPred)=YES %then %do;
				%if &residnum=0 %then %do;
					%let _outpnum= &residnum;
					%let ErrString= The residuals for the Trend Association Test could not be computed.;
				%end;
				%else %if &prednum=0 %then %do;
					%let _outpnum= &prednum;
					%let ErrString= The predicted values for the Trend Association Test could not be computed.;
				%end;
				%else %do;
					%let _outpnum= &residnum;
				%end;
			%end;
			%else %if %upcase(&OutputResid)=YES and %upcase(&OutputPred)^=YES  %then %do;
				%let _outpnum= &residnum;
				%if &residnum=0 %then
					%let ErrString= The residuals for the Trend Association Test could not be computed.;
			%end;
			%else %if %upcase(&OutputResid)^=YES and %upcase(&OutputPred)=YES  %then %do;
				%let _outpnum= &prednum;
				%if &prednum=0 %then
					%let ErrString= The predicted values for the Trend Association Test could not be computed.;
			%end;
			
			%if &nobs=0 %then %do;
				%if %upcase(&OutputResid)=YES and %upcase(&OutputPred)=YES %then
					%let ErrString= Either the residuals or predicted values for the Trend Association Test could not be computed.;
				%else %if %upcase(&OutputResid)=YES and %upcase(&OutputPred)^=YES %then
					%let ErrString= The residuals for the Trend Association Test could not be computed.;
				%else %if %upcase(&OutputResid)^=YES and %upcase(&OutputPred)=YES %then
					%let ErrString= The predicted values for the Trend Association Test could not be computed.;
			%end;
			
			%if &nobs=0 or &_outpnum=0 %then %do;
				%*put ERROR: The trend residuals could not be computed.;
				%put WARNING: &ErrString;
				%let OutputResid=NO;
				%let OutputPred=NO;
				
				%let SNPTraitAssocMacro_ScErr= &ProcessName._ScErr;
				%*put ScriptErr= &SNPTraitAssocMacro_ScErr;
		    		%global &SNPTraitAssocMacro_ScErr;
				%PrepOutFile(&SNPTraitAssocMacro_ScErr,&SNPTraitAssocMacro_ScErr.Name,saserror.jsl);
				%*put ScriptErr= &&&SNPTraitAssocMacro_ScErr;
				%*put ScriptErrName= &&&SNPTraitAssocMacro_ScErr.Name;

				data _null_;
					file "&&&SNPTraitAssocMacro_ScErr" lrecl=32767 ;
					put '//!' ;
					put "Names Default to Here(1);" ;
					put "new Window(""WARNING running &FullAPName.""," ;
					put "vlb=VListBox(" ; 
					put "textBox(""The following SAS warning ocurred in process &FullAPName:""),";
					put "errtxt = TextEditBox(""\!N""||""";
					put "&ErrString.";
					put """||""\!N"",WhiteBoxStyle(0)),";
					put "errtxt << Font Color(3)," ; 
					put "errtxt << Set Wrap(1000)," ;
					/*put "TextBox(""Please refer to the SAS log displayed in the JMP log window for further details.\!N\!N""),";*/
					put ")" ;
					put ");";
				run;
	  			%PackageInsertFile(jsl code from &ProcessName, &OutPath, &&&SNPTraitAssocMacro_ScErr.Name, no, no, yes);
			%end;
			%else %do;

				%if &NTrait>1 %then %do;
					proc sort data=outrest_all;
						by _order_;
					run;
				%end;

				data outrest_all;
					merge mapdata outrest_all;
					by _order_;
					%if %length(&selmarkervarsorder_t) %then %do;  
						where _order_ not in (%sysfunc(tranwrd(&selmarkervarsorder_t, %str( ), %str(,))));
					%end;
				run;

				proc sort data=outrest_all;
					by _individ_ _order_ _Trait_ ;
				run;
				
				%if %upcase(&OutputResid)=YES %then %do;
					proc transpose data=outrest_all out=outrestt(drop= _name_) let
						%if &NTrait>1 %then %do;
							prefix=Res_ delimiter=_Trt_
						%end;
						%else %do;
							prefix=Resid_
						%end;
						;
						var resid;
						id %if &NTrait>1 %then _order_  _Trait_; %else &AnnoLabel;;
						by _IndivID_;
					run;

					data &SNPTraitAssoc_ORT;
						 merge othervars outrestt;
						 by _IndivID_;
						 %if ^&QKSelProf %then %do;
						 	drop _individ_;
						 %end;
					run;

					%if %upcase(&ProcessName) ^= QKMIXEDMODEL %then %do;
						%PackageInsertDataset(Trend residual data from &ProcessName, OutLib, &SNPTraitAssoc_ORTName);
					%end;
				%end;
				
				%if %upcase(&OutputPred)=YES %then %do;
					proc transpose data=outrest_all out=outpredtt(drop= _name_) let
						%if &NTrait>1 %then %do;
							prefix=Pred_ delimiter=_Trt_
						%end;
						%else %do;
							prefix=Pred_
						%end;
						;
						var pred;
						id %if &NTrait>1 %then _order_  _Trait_; %else &AnnoLabel;;
						by _IndivID_;
					run;

					data &SNPTraitAssoc_OPT;
						 merge othervars outpredtt;
						 by _IndivID_;
						 %if ^&QKSelProf %then %do;
						 	drop _individ_;
						 %end;
					run;

					%if %upcase(&ProcessName) ^= QKMIXEDMODEL %then %do;
						%PackageInsertDataset(Trend predicted data from &ProcessName, OutLib, &SNPTraitAssoc_OPTName);
					%end;				
				%end;
			%end;

		%end;	

		%if &pest=1 %then %do;
			data &SNPTraitAssoc_PET;
				merge mapdata pat_all%if &imputed=1 %then (drop=&SNPIDVar);;
				by _order_;
				%if %length(&selmarkervarsorder_t) %then %do;  
					where _order_ not in (%sysfunc(tranwrd(&selmarkervarsorder_t, %str( ), %str(,))));
				%end;
				drop %if ^&QKSelProf %then _order_; _ESTTYPE_ %if &OutputMajAllele %then MajorAllele;;
			run;	

			%if %upcase(&ProcessName) ^= QKMIXEDMODEL %then %do;
				%PackageInsertDataset(Trend parameter estimate data from &ProcessName, OutLib, &SNPTraitAssoc_PETName, _type=other);
			%end;
		%end;

		%if (&kmodel=1 or %length(&RandEff)) and &covp %then %do;
			data &SNPTraitAssoc_CPT;
				merge mapdata cpt_all;
				by _order_;
				%if %length(&selmarkervarsorder_t) %then %do;  
					where _order_ not in (%sysfunc(tranwrd(&selmarkervarsorder_t, %str( ), %str(,))));
				%end;
				%if ^&QKSelProf or &OutputMajAllele %then %do;
					drop %if ^&QKSelProf %then _order_; %if &OutputMajAllele %then MajorAllele;;
				%end;
			run;

			%if %upcase(&ProcessName) ^= QKMIXEDMODEL %then %do;
				%PackageInsertDataset(Trend covariance parameter data from &ProcessName, OutLib, &SNPTraitAssoc_CPTName, _type=other);
			%end;

		%end;		

		%if %upcase(&OutputSurvFunc)=YES %then %do;

			proc sort data=sft_all;
				by _order_;
			run;

			data &SNPTraitAssoc_sft;
				merge mapdata sft_all;
				by _order_;
				%if ^&QKSelProf or &OutputMajAllele or &NeedConstant %then %do;
					drop %if ^&QKSelProf %then _order_; %if &OutputMajAllele %then MajorAllele; %if &NeedConstant %then constant;;
				%end;
			run;

			%if %upcase(&ProcessName) ^= QKMIXEDMODEL %then %do;
				%PackageInsertDataset(Trend survival function data from &ProcessName, OutLib, &SNPTraitAssoc_sftName);
			%end;	

		%end;
	%end;

	%let mergeds=;
	%if &geno=1 %then %let mergeds=ma_a;
	%if &trend=1 %then %let mergeds = &mergeds ta_all;
	%if &survey=1 %then %do;
		%if &raoscottf=1 or &raoscottchi=1 %then %let mergeds= &mergeds rs_all;
	%end;   
	
	data ma_all;
		merge &mergeds;
		by &AnnoGroup &AnnoLoc &ByVars Effect;
		%if &osig=1 %then %do;
			%if &geno=1 and &trend=1 %then %do;
				if ProbGenotype < &Alpha or ProbTrend < &Alpha; 
			%end;
			%else %if &geno=1 %then %do;
				if ProbGenotype < &Alpha;
			%end;
			%else %if &trend=1 %then %do;
				if ProbTrend < &Alpha;
			%end;
		%end;
	run; 

	title;
	title2;
	title3;

	%global PlotVar1 PlotVar2 PlotVar3 PlotVar4 QTests;

	%if &survey=0 %then %do;
		%let PlotVar1=%scan(&QTests,1);
		%if &PerfPerm %then %do;
			%let PlotVar1 = &PlotVar1.Perm;
			%if %upcase(&AdjPerm)=YES %then %do;
				%let PlotVar1= &PlotVar1.Adj;
			%end;
		%end;

		%if %length(%scan(&QTests,2)) %then %do;
			%let PlotVar2=%scan(&QTests,2);
			%if &PerfPerm %then %do;
				%let PlotVar2 = &PlotVar2.Perm;	
				%if %upcase(&AdjPerm)=YES %then %do;
					%let PlotVar2= &PlotVar2.Adj;
				%end;			
			%end;
		%end;

		%let QTests = &PlotVar1 &PlotVar2;
		%if &lsm %then %let QTests = &QTests LSDiff_1_0 LSDiff_2_0;
	%end;
	%else %do;
		%let s=1;
		%let QTests_new=;
		%do %while(%length(%scan(&QTests,&s)));
			%let ctest = %scan(&QTests,&s);
			%if %index(&ctest,Rao)>0 %then %let PlotVar&s=_RaoScott_%substr(&ctest,10);
			%else %let PlotVar&s=&ctest;
			%let QTests_new = &QTests_new &&PlotVar&s;
			%let s=%eval(&s+1);
		%end;
		%let QTests = &QTests_new;
	%end;

	%if %length(&IntEff)>0 %then %do;
		%if %length(&ByVars)>0 %then %do;	
			%let ByVars=&ByVars Effect;
			%let JBy = %str(&JBy,Effect);
		%end;
		%else %do;
		 %let ByVars = Effect;
		 %let JBy=Effect;

		%end;
		%let Nbyval = %eval(&Nbyval*&NumInt);
		%let lastby = Effect;
	%end;

	%exitm:;

%mend;
